/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 16 "gram.y" /* yacc.c:339  */

#include "./dbpmda.h"
#include "./lex.h"

extern int stmt_type;

static union {
    pmID	whole;
    __pmID_int	part;
} pmid;

static union {
    pmInDom		whole;
    __pmInDom_int	part;
} indom;


static int	sts;
static int	inst;
static char	*str;
#define MYWARNSTRSZ 80
static char	warnStr[MYWARNSTRSZ];

param_t	param;

/*
 * pmidp may contain a dynamic PMID ... if so, ask the PMDA to
 * translate name if possible
 */
static int
fix_dynamic_pmid(const char *name, pmID *pmidp)
{
    int		sts;
    __pmPDU	*pb;
    extern int	toPMDA;
    extern int	fromPMDA;
    extern pmdaInterface	dispatch;

    if (IS_DYNAMIC_ROOT(*pmidp)) {
	if (connmode == CONN_DSO) {
	    if (dispatch.comm.pmda_interface >= PMDA_INTERFACE_4) {
		sts = dispatch.version.four.pmid(name, pmidp, dispatch.version.four.ext);
		if (sts < 0) return sts;
	    }
	}
	else if (connmode == CONN_DAEMON) {
	    sts = __pmSendNameList(toPMDA, FROM_ANON, 1, &name, NULL);
	    if (sts < 0) return sts;
	    sts = __pmGetPDU(fromPMDA, ANY_SIZE, TIMEOUT_NEVER, &pb);
	    if (sts < 0) return sts;
	    if (sts == PDU_PMNS_IDS) {
		int	xsts;
		sts = __pmDecodeIDList(pb, 1, pmidp, &xsts);
		__pmUnpinPDUBuf(pb);
		if (sts < 0) return sts;
		return xsts;
	    }
	    else if (sts == PDU_ERROR) {
		__pmDecodeError(pb, &sts);
		__pmUnpinPDUBuf(pb);
		return sts;
	    }
	}
    }
    return 0;
}



#line 136 "gram.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.tab.h".  */
#ifndef YY_YY_GRAM_TAB_H_INCLUDED
# define YY_YY_GRAM_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NUMBER2D = 258,
    NUMBER3D = 259,
    NUMBER = 260,
    NEGNUMBER = 261,
    FLAG = 262,
    NAME = 263,
    PATHNAME = 264,
    MACRO = 265,
    STRING = 266,
    COMMA = 267,
    EQUAL = 268,
    OPEN = 269,
    CLOSE = 270,
    DESC = 271,
    GETDESC = 272,
    GETINAME = 273,
    FETCH = 274,
    INSTANCE = 275,
    PROFILE = 276,
    HELP = 277,
    WATCH = 278,
    DBG = 279,
    QUIT = 280,
    STATUS = 281,
    STORE = 282,
    INFO = 283,
    TIMER = 284,
    NAMESPACE = 285,
    WAIT = 286,
    PMNS_NAME = 287,
    PMNS_PMID = 288,
    PMNS_CHILDREN = 289,
    PMNS_TRAVERSE = 290,
    ATTR = 291,
    LABEL = 292,
    CTXT = 293,
    DOMAIN = 294,
    INDOM = 295,
    CLUSTER = 296,
    ITEM = 297,
    INSTANCES = 298,
    DSO = 299,
    PIPE = 300,
    SOCK = 301,
    UNIX = 302,
    INET = 303,
    IPV6 = 304,
    ADD = 305,
    DEL = 306,
    ALL = 307,
    NONE = 308,
    ON = 309,
    OFF = 310,
    PLUS = 311,
    EOL = 312
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 86 "gram.y" /* yacc.c:355  */

	char		*y_str;
	int		y_num;
	twodot_num      y_2num;
	threedot_num    y_3num;
	

#line 242 "gram.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAM_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 259 "gram.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  127
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   256

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  58
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  15
/* YYNRULES -- Number of rules.  */
#define YYNRULES  127
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  230

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   312

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   137,   137,   141,   145,   149,   153,   157,   161,   165,
     168,   172,   176,   180,   183,   187,   192,   196,   201,   206,
     210,   216,   222,   228,   232,   242,   252,   263,   274,   278,
     282,   286,   290,   294,   298,   302,   306,   310,   314,   318,
     322,   327,   332,   336,   340,   344,   349,   354,   359,   365,
     369,   373,   377,   381,   385,   389,   393,   397,   401,   405,
     409,   413,   417,   421,   425,   429,   433,   437,   441,   445,
     449,   453,   457,   462,   463,   467,   476,   485,   488,   491,
     495,   498,   501,   505,   508,   511,   515,   518,   521,   525,
     528,   529,   539,   550,   553,   554,   557,   566,   577,   578,
     591,   603,   617,   632,   647,   651,   659,   663,   667,   675,
     684,   685,   686,   690,   693,   694,   697,   708,   717,   728,
     739,   748,   764,   765,   766,   767,   768,   769
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER2D", "NUMBER3D", "NUMBER",
  "NEGNUMBER", "FLAG", "NAME", "PATHNAME", "MACRO", "STRING", "COMMA",
  "EQUAL", "OPEN", "CLOSE", "DESC", "GETDESC", "GETINAME", "FETCH",
  "INSTANCE", "PROFILE", "HELP", "WATCH", "DBG", "QUIT", "STATUS", "STORE",
  "INFO", "TIMER", "NAMESPACE", "WAIT", "PMNS_NAME", "PMNS_PMID",
  "PMNS_CHILDREN", "PMNS_TRAVERSE", "ATTR", "LABEL", "CTXT", "DOMAIN",
  "INDOM", "CLUSTER", "ITEM", "INSTANCES", "DSO", "PIPE", "SOCK", "UNIX",
  "INET", "IPV6", "ADD", "DEL", "ALL", "NONE", "ON", "OFF", "PLUS", "EOL",
  "$accept", "stmt", "fname", "optdomain", "attribute", "servport",
  "metric", "cluster", "indom", "raw_pmid", "metriclist", "arglist",
  "inst", "debug", "flag", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312
};
# endif

#define YYPACT_NINF -91

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-91)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     120,    59,   -28,    17,    74,   104,    23,    33,    38,   155,
      37,    45,    -8,    -1,    29,     2,   108,    68,    12,     0,
      22,    27,    39,    13,   159,   -91,    63,    68,    68,    64,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,    10,    14,    30,
     -91,    35,    42,   -91,   -91,   -91,    11,   -91,   -91,   -91,
     -91,    43,   -91,    71,    50,    52,    58,    62,    69,   103,
     111,   137,   138,   146,   147,   148,   149,   151,   153,   154,
     156,   157,   158,   160,   162,   163,   164,   -91,   -91,   -91,
     -91,   165,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   166,
     168,   -91,    70,   -91,   -91,   -91,   -91,   114,   161,   -91,
     170,   172,   173,   -91,   174,   175,   -91,   -91,   -91,   176,
     177,   -91,   178,   -91,   179,   -91,   -91,   -91,   -91,    44,
     180,   181,   161,   127,    57,   161,   -91,   -91,   210,   -91,
      68,    47,    47,   -91,   -91,   -91,   -91,   -91,   -91,    57,
     -91,   -91,   182,   -91,   -91,   -91,   183,   236,   237,   186,
     187,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,   -91,   -91,   188,   -91,
     -91,   189,   190,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   191,   -91,   -91,   -91,   192,   -91,   -91,   193,
     194,   195,   240,   -91,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   196,   197,   -91,   -91,   -91,   -91,   -91,   -91,
     -91,   -91,   -91,   -91,   -91,   -91,   198,   -91,   -91,   -91
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      91,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    90,     0,     0,     0,     0,
       2,     9,   101,   102,   100,   103,    10,     0,     0,     0,
      82,     0,     0,    85,    12,   110,     0,   108,   106,   107,
      19,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    49,    92,    93,
      28,     0,   116,   122,   123,   124,   127,   125,   126,     0,
       0,    74,     0,   117,    73,    78,    14,     0,     0,    16,
       0,     0,     0,    79,     0,     0,    88,   109,    30,     0,
       0,    32,     0,    34,     0,    36,    96,    97,    39,     0,
       0,     0,     0,     0,     0,     0,    42,     1,     0,   113,
       0,     0,     0,     5,    11,    83,    84,    86,    87,     0,
      13,   111,     0,   115,   114,    20,     0,     0,     0,     0,
       0,    61,    51,    53,    55,    56,    54,    58,    66,    72,
      52,    67,    68,    69,    57,    70,    60,    71,    63,    64,
      62,    65,    50,    59,    29,    75,    76,   118,     0,    77,
     120,     0,     0,    17,    80,    81,    38,    89,    31,    33,
      35,    37,     0,    40,    43,    44,     0,   105,   104,     0,
       0,     0,    95,     4,     6,    98,    99,     7,     8,   112,
      21,    22,     0,     0,    24,    25,   119,   121,    15,    18,
      41,    45,    46,    47,    48,    94,     0,    26,    27,     3
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -91,   -91,   -16,   -91,   -91,   124,    -6,   -91,    -5,   -91,
     -91,   -91,   -91,   -91,   -90
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    26,    81,   226,   119,   207,    37,   199,    51,   109,
      46,   203,   146,    92,    93
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      45,   104,   180,    53,   107,    32,    33,    34,    97,   100,
      35,   128,   129,   133,    32,    33,    34,   105,   116,    35,
      32,    33,    34,   139,   117,    35,    32,    33,    34,    31,
     110,    35,    32,    33,    34,   112,    47,    35,    48,    49,
     141,    47,    98,    48,    49,    78,    79,   114,   142,    94,
      82,   143,   205,    83,   144,   192,    95,   108,   206,    99,
      32,    33,    34,   127,    84,    35,    85,   134,   140,   106,
     118,   135,    78,    79,    36,   177,    78,    79,    83,   111,
      44,    86,   178,    87,   113,    88,    96,   136,   217,    84,
      50,    85,   137,   182,    80,    52,   115,    89,    90,   138,
     145,   193,    91,    27,    28,    29,    86,   151,    87,   152,
      88,   130,   131,   132,   204,   153,    30,   196,   200,   154,
     201,   147,   148,   149,   150,   181,   155,   179,    38,    39,
     197,    40,   198,   209,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    41,    42,
     156,    43,   101,   102,    47,   103,    48,    49,   157,    54,
      55,    56,    57,    58,    59,    60,    61,    25,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,   216,   158,   159,    83,   120,   121,   122,
     123,   124,   125,   160,   161,   162,   163,    84,   164,    85,
     165,   166,    77,   167,   168,   169,   126,   170,   202,   171,
     172,   173,   174,   175,    86,   176,    87,   183,    88,   184,
     185,   186,   187,   188,   189,   190,   191,   194,   195,   210,
     211,   212,   213,   214,   215,   225,   218,   219,   220,   221,
     222,   223,   224,   227,   228,   229,   208
};

static const yytype_uint8 yycheck[] =
{
       6,    17,    92,     8,     4,     3,     4,     5,    14,    15,
       8,    27,    28,    29,     3,     4,     5,     5,     5,     8,
       3,     4,     5,    12,    11,     8,     3,     4,     5,    57,
       8,     8,     3,     4,     5,     8,     3,     8,     5,     6,
      46,     3,    40,     5,     6,     8,     9,     8,     5,    57,
       5,     8,     5,     8,    11,    11,    57,    57,    11,    57,
       3,     4,     5,     0,    19,     8,    21,    57,    57,    57,
      57,    57,     8,     9,    57,     5,     8,     9,     8,    57,
      57,    36,    12,    38,    57,    40,    57,    57,   178,    19,
      57,    21,    57,    98,    57,    57,    57,    52,    53,    57,
      57,    57,    57,    44,    45,    46,    36,    57,    38,    57,
      40,    47,    48,    49,   130,    57,    57,   122,   124,    57,
     125,    50,    51,    52,    53,    11,    57,    57,    54,    55,
       3,    57,     5,   139,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    54,    55,
      57,    57,    54,    55,     3,    57,     5,     6,    57,    14,
      15,    16,    17,    18,    19,    20,    21,    57,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,     5,    57,    57,     8,    38,    39,    40,
      41,    42,    43,    57,    57,    57,    57,    19,    57,    21,
      57,    57,    57,    57,    57,    57,    57,    57,     8,    57,
      57,    57,    57,    57,    36,    57,    38,    57,    40,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,     5,     5,    57,    57,     5,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,   132
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    57,    59,    44,    45,    46,
      57,    57,     3,     4,     5,     8,    57,    64,    54,    55,
      57,    54,    55,    57,    57,    64,    68,     3,     5,     6,
      57,    66,    57,    66,    14,    15,    16,    17,    18,    19,
      20,    21,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    57,     8,     9,
      57,    60,     5,     8,    19,    21,    36,    38,    40,    52,
      53,    57,    71,    72,    57,    57,    57,    64,    40,    57,
      64,    54,    55,    57,    60,     5,    57,     4,    57,    67,
       8,    57,     8,    57,     8,    57,     5,    11,    57,    62,
      38,    39,    40,    41,    42,    43,    57,     0,    60,    60,
      47,    48,    49,    60,    57,    57,    57,    57,    57,    12,
      57,    64,     5,     8,    11,    57,    70,    50,    51,    52,
      53,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,     5,    12,    57,
      72,    11,    66,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    11,    57,    57,    57,    66,     3,     5,    65,
      64,    66,     8,    69,    60,     5,    11,    63,    63,    64,
      57,    57,     5,     5,    57,    57,     5,    72,    57,    57,
      57,    57,    57,    57,    57,     5,    61,    57,    57,    57
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    58,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    60,    60,    61,    61,    62,    62,    63,    63,
      64,    64,    64,    64,    65,    65,    66,    66,    66,    67,
      68,    68,    68,    69,    70,    70,    71,    71,    71,    71,
      71,    71,    72,    72,    72,    72,    72,    72
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     6,     4,     3,     4,     4,     4,     2,
       2,     3,     2,     3,     2,     4,     2,     3,     4,     2,
       3,     4,     4,     2,     4,     4,     5,     5,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     2,
       3,     4,     2,     3,     3,     4,     4,     4,     4,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     3,     3,     3,     2,     2,
       3,     3,     2,     3,     3,     2,     3,     3,     2,     3,
       1,     0,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     3,     0,     1,     1,     1,     1,     2,     3,
       2,     3,     1,     1,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 137 "gram.y" /* yacc.c:1646  */
    {
		param.number = OPEN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1501 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 141 "gram.y" /* yacc.c:1646  */
    {
		opendso((yyvsp[-3].y_str), (yyvsp[-2].y_str), (yyvsp[-1].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1510 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 145 "gram.y" /* yacc.c:1646  */
    {
		openpmda((yyvsp[-1].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1519 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 149 "gram.y" /* yacc.c:1646  */
    {
		open_unix_socket((yyvsp[0].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1528 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 153 "gram.y" /* yacc.c:1646  */
    {
		open_unix_socket((yyvsp[0].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1537 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 157 "gram.y" /* yacc.c:1646  */
    {
		open_inet_socket((yyvsp[0].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1546 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 161 "gram.y" /* yacc.c:1646  */
    {
		open_ipv6_socket((yyvsp[0].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1555 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 165 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = CLOSE; YYACCEPT; 
	    }
#line 1563 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 168 "gram.y" /* yacc.c:1646  */
    {
		param.number = DESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1572 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 172 "gram.y" /* yacc.c:1646  */
    {
		param.pmid = (yyvsp[-1].y_num);
		stmt_type = DESC; YYACCEPT;
	    }
#line 1581 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 176 "gram.y" /* yacc.c:1646  */
    {
		param.number = FETCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1590 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 180 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = FETCH; YYACCEPT; 
	    }
#line 1598 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 183 "gram.y" /* yacc.c:1646  */
    {
		param.number = STORE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1607 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 187 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		param.pmid = (pmID)(yyvsp[-2].y_num);
		stmt_type = STORE; YYACCEPT;
	    }
#line 1617 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 192 "gram.y" /* yacc.c:1646  */
    {
		param.number = INFO; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1626 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 196 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_TEXT_PMID;
		param.pmid = (pmID)(yyvsp[-1].y_num);
		stmt_type = INFO; YYACCEPT;
	    }
#line 1636 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 201 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_TEXT_INDOM;
		param.indom = indom.whole;
		stmt_type = INFO; YYACCEPT;
	    }
#line 1646 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 206 "gram.y" /* yacc.c:1646  */
    {
		param.number = INSTANCE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1655 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 210 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1666 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 216 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = (yyvsp[-1].y_num);
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1677 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 222 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = (yyvsp[-1].y_str);
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1688 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 228 "gram.y" /* yacc.c:1646  */
    {
		param.number = PROFILE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1697 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 232 "gram.y" /* yacc.c:1646  */
    {
		sts = pmAddProfile((yyvsp[-2].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1712 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 242 "gram.y" /* yacc.c:1646  */
    {
		sts = pmDelProfile((yyvsp[-2].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1727 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 252 "gram.y" /* yacc.c:1646  */
    {
		inst = (yyvsp[-1].y_num);
		sts = pmAddProfile((yyvsp[-3].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1743 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 263 "gram.y" /* yacc.c:1646  */
    {
		inst = (yyvsp[-1].y_num);
		sts = pmDelProfile((yyvsp[-3].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1759 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 274 "gram.y" /* yacc.c:1646  */
    {
		param.number = WATCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1768 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 278 "gram.y" /* yacc.c:1646  */
    {
		watch((yyvsp[-1].y_str));
		stmt_type = WATCH; YYACCEPT;
	    }
#line 1777 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 282 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_NAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1786 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 286 "gram.y" /* yacc.c:1646  */
    {
		param.pmid = (yyvsp[-1].y_num);
		stmt_type = PMNS_NAME; YYACCEPT;
	    }
#line 1795 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 290 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_PMID; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1804 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 294 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_PMID; YYACCEPT;
	    }
#line 1813 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 298 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1822 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 302 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_CHILDREN; YYACCEPT;
	    }
#line 1831 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 306 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1840 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 310 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_TRAVERSE; YYACCEPT;
	    }
#line 1849 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 314 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = NAMESPACE; YYACCEPT;
	    }
#line 1858 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 318 "gram.y" /* yacc.c:1646  */
    {
		param.number = ATTR; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1867 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 322 "gram.y" /* yacc.c:1646  */
    {
		param.number = (yyvsp[-1].y_num);
		param.name = NULL;
		stmt_type = ATTR; YYACCEPT;
	    }
#line 1877 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 327 "gram.y" /* yacc.c:1646  */
    {
		param.number = (yyvsp[-2].y_num);
		param.name = (yyvsp[-1].y_str);
		stmt_type = ATTR; YYACCEPT;
	    }
#line 1887 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 332 "gram.y" /* yacc.c:1646  */
    {
		param.number = LABEL; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1896 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 336 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_CONTEXT;
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1905 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 340 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_DOMAIN;
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1914 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 344 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_INDOM;
		param.indom = indom.whole;
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1924 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 349 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_CLUSTER;
		param.pmid = (pmID)(yyvsp[-1].y_num);
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1934 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 354 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_ITEM;
		param.pmid = (pmID)(yyvsp[-1].y_num);
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1944 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 359 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_LABEL_INSTANCES;
		param.indom = indom.whole;
		stmt_type = LABEL; YYACCEPT;
	    }
#line 1954 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 365 "gram.y" /* yacc.c:1646  */
    { 
		param.number = -1; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT; 
	    }
#line 1963 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 369 "gram.y" /* yacc.c:1646  */
    {
		param.number = ATTR; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1972 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 373 "gram.y" /* yacc.c:1646  */
    {
		param.number = CLOSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1981 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 377 "gram.y" /* yacc.c:1646  */
    {
		param.number = DBG; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1990 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 381 "gram.y" /* yacc.c:1646  */
    {
		param.number = DESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1999 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 385 "gram.y" /* yacc.c:1646  */
    {
		param.number = FETCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2008 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 389 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETDESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2017 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 393 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETINAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2026 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 397 "gram.y" /* yacc.c:1646  */
    {
		param.number = INFO; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2035 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 401 "gram.y" /* yacc.c:1646  */
    {
		param.number = INSTANCE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2044 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 405 "gram.y" /* yacc.c:1646  */
    {
		param.number = LABEL; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2053 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 409 "gram.y" /* yacc.c:1646  */
    {
		param.number = NAMESPACE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2062 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 413 "gram.y" /* yacc.c:1646  */
    {
		param.number = OPEN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2071 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 417 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2080 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 421 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_NAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2089 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 425 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_PMID; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2098 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 429 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2107 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 433 "gram.y" /* yacc.c:1646  */
    {
		param.number = PROFILE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2116 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 437 "gram.y" /* yacc.c:1646  */
    {
		param.number = QUIT; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2125 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 441 "gram.y" /* yacc.c:1646  */
    {
		param.number = STATUS; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2134 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 445 "gram.y" /* yacc.c:1646  */
    {
		param.number = STORE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2143 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 449 "gram.y" /* yacc.c:1646  */
    {
		param.number = TIMER; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2152 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 453 "gram.y" /* yacc.c:1646  */
    {
		param.number = WAIT; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2161 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 457 "gram.y" /* yacc.c:1646  */
    {
		param.number = WATCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2170 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 462 "gram.y" /* yacc.c:1646  */
    { stmt_type = QUIT; YYACCEPT; }
#line 2176 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 463 "gram.y" /* yacc.c:1646  */
    {
		param.number = DBG; param.pmid = HELP_USAGE; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2185 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 467 "gram.y" /* yacc.c:1646  */
    {
		sts = pmSetDebug("all");
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "pmSetDebug(\"all\") failed\n");
		    yywarn(warnStr);
		    YYERROR;
		}
		stmt_type = DBG; YYACCEPT;
	    }
#line 2199 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 476 "gram.y" /* yacc.c:1646  */
    {
		sts = pmClearDebug("all");
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "pmClearDebug(\"all\") failed\n");
		    yywarn(warnStr);
		    YYERROR;
		}
		stmt_type = DBG; YYACCEPT;
	    }
#line 2213 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 485 "gram.y" /* yacc.c:1646  */
    {
	        stmt_type = DBG; YYACCEPT;
	    }
#line 2221 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 488 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = STATUS; YYACCEPT; 
	    }
#line 2229 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 491 "gram.y" /* yacc.c:1646  */
    {
		param.number = TIMER; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2238 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 495 "gram.y" /* yacc.c:1646  */
    { 
		timer = 1; stmt_type = EOL; YYACCEPT; 
	    }
#line 2246 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 498 "gram.y" /* yacc.c:1646  */
    { 
		timer = 0; stmt_type = EOL; YYACCEPT; 
	    }
#line 2254 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 501 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETDESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2263 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 505 "gram.y" /* yacc.c:1646  */
    { 
		get_desc = 1; stmt_type = EOL; YYACCEPT; 
	    }
#line 2271 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 508 "gram.y" /* yacc.c:1646  */
    { 
		get_desc = 0; stmt_type = EOL; YYACCEPT; 
	    }
#line 2279 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 511 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETINAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2288 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 515 "gram.y" /* yacc.c:1646  */
    { 
		get_iname = 1; stmt_type = EOL; YYACCEPT; 
	    }
#line 2296 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 518 "gram.y" /* yacc.c:1646  */
    { 
		get_iname = 0; stmt_type = EOL; YYACCEPT; 
	    }
#line 2304 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 521 "gram.y" /* yacc.c:1646  */
    {
		param.number = WAIT; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2313 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 525 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = EOL; sleep((yyvsp[-1].y_num)); YYACCEPT;
	    }
#line 2321 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 528 "gram.y" /* yacc.c:1646  */
    { stmt_type = EOL; YYACCEPT; }
#line 2327 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 529 "gram.y" /* yacc.c:1646  */
    {
		if (yywrap())
		    YYACCEPT;
		else {
		    yyerror("Unrecognized command");
		    YYERROR;
		}
	    }
#line 2340 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 539 "gram.y" /* yacc.c:1646  */
    {
		    /* check for absolute path - *nix and Windows style */
		    if ((yyvsp[0].y_str)[0] == '/' ||
		        (strlen((yyvsp[0].y_str)) > 4 && (yyvsp[0].y_str)[1] == ':' && (yyvsp[0].y_str)[2] == '/'))
			(yyval.y_str) = (yyvsp[0].y_str);
		    else {
			/* relative path */
			(yyval.y_str) = strcons("./", (yyvsp[0].y_str));
			gc_add((yyval.y_str));
		    }
	    }
#line 2356 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 550 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2362 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 553 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[0].y_num); }
#line 2368 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 554 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = 0; }
#line 2374 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 557 "gram.y" /* yacc.c:1646  */
    {
		sts = __pmAttrKeyStr_r((yyvsp[0].y_num), warnStr, sizeof(warnStr));
		if (sts <= 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Attribute (%d) is not recognised", (yyvsp[0].y_num));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = (yyvsp[0].y_num);
	    }
#line 2388 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 566 "gram.y" /* yacc.c:1646  */
    { 
		sts = __pmLookupAttrKey((yyvsp[0].y_str), strlen((yyvsp[0].y_str))+1);
		if (sts <= 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Attribute (%s) is not recognised", (yyvsp[0].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = sts;
	    }
#line 2402 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 577 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[0].y_num); }
#line 2408 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 578 "gram.y" /* yacc.c:1646  */
    {
		struct servent *srv = getservbyname((yyvsp[0].y_str), NULL);
		if (srv == NULL) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "Failed to map (%s) to a port number", (yyvsp[0].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		pmsprintf(warnStr, MYWARNSTRSZ, "Mapped %s to port number %d", (yyvsp[0].y_str), srv->s_port);
		yywarn(warnStr);
		(yyval.y_num) = srv->s_port;
	    }
#line 2424 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 591 "gram.y" /* yacc.c:1646  */
    { 
		pmid.whole = (yyvsp[0].y_num);
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole; 
	    }
#line 2441 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 603 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.cluster = (yyvsp[0].y_2num).num1;
		pmid.part.item = (yyvsp[0].y_2num).num2;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2460 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 617 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[0].y_3num).num1;
		pmid.part.cluster = (yyvsp[0].y_3num).num2;
		pmid.part.item = (yyvsp[0].y_3num).num3;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    pmsprintf(warnStr, MYWARNSTRSZ, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2480 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 632 "gram.y" /* yacc.c:1646  */
    {
		sts = pmLookupName(1, (const char **)&(yyvsp[0].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		sts = fix_dynamic_pmid((yyvsp[0].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2498 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 647 "gram.y" /* yacc.c:1646  */
    { 
		pmid.whole = (yyvsp[0].y_num);
	        (yyval.y_num) = (int)pmid.whole;
	    }
#line 2507 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 651 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[0].y_2num).num1;
		pmid.part.cluster = (yyvsp[0].y_2num).num2;
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2518 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 659 "gram.y" /* yacc.c:1646  */
    { 
		indom.whole = (yyvsp[0].y_num);
	        (yyval.y_num) = (int)indom.whole;
	    }
#line 2527 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 663 "gram.y" /* yacc.c:1646  */
    { 
		indom.whole = (yyvsp[0].y_num);
		(yyval.y_num) = (int)indom.whole;
	    }
#line 2536 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 667 "gram.y" /* yacc.c:1646  */
    {
		indom.whole = 0;
		indom.part.domain = (yyvsp[0].y_2num).num1;
		indom.part.serial = (yyvsp[0].y_2num).num2;
		(yyval.y_num) = (int)indom.whole;
	    }
#line 2547 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 675 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[0].y_3num).num1;
		pmid.part.cluster = (yyvsp[0].y_3num).num2;
		pmid.part.item = (yyvsp[0].y_3num).num3;
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2559 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 684 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2565 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 685 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2571 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 686 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2577 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 690 "gram.y" /* yacc.c:1646  */
    { doargs(); }
#line 2583 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 693 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2589 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 694 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2595 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 697 "gram.y" /* yacc.c:1646  */
    {
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[0].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2611 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 708 "gram.y" /* yacc.c:1646  */
    {
			sts = pmSetDebug((yyvsp[0].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[0].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2625 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 717 "gram.y" /* yacc.c:1646  */
    {
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[0].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2641 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 728 "gram.y" /* yacc.c:1646  */
    {
			char	nbuf[12];
			pmsprintf(nbuf, sizeof(nbuf), "%d", (yyvsp[0].y_num));
			sts = pmSetDebug(nbuf);
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", nbuf);
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2657 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 739 "gram.y" /* yacc.c:1646  */
    {
			sts = pmSetDebug((yyvsp[0].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[0].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2671 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 748 "gram.y" /* yacc.c:1646  */
    {
			sts = pmSetDebug((yyvsp[0].y_str));
			if (sts < 0) {
			    pmsprintf(warnStr, MYWARNSTRSZ, "Bad debug flag (%s)", (yyvsp[0].y_str));
			    yyerror(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = 0;
		    }
#line 2685 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 764 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2691 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 765 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strdup("fetch"); gc_add((yyval.y_str)); }
#line 2697 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 766 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strdup("profile"); gc_add((yyval.y_str)); }
#line 2703 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 767 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strdup("context"); gc_add((yyval.y_str)); }
#line 2709 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 768 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strdup("indom"); gc_add((yyval.y_str)); }
#line 2715 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 769 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strdup("attr"); gc_add((yyval.y_str)); }
#line 2721 "gram.tab.c" /* yacc.c:1646  */
    break;


#line 2725 "gram.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 772 "gram.y" /* yacc.c:1906  */

