/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "query_parser.y" /* yacc.c:339  */

/*
 * query_parser.y - yacc/bison grammar for the PCP time series language
 *
 * Copyright (c) 2017-2019 Red Hat.
 * Copyright (c) 2020 Yushan ZHANG.
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 */

#include <ctype.h>
#include "query.h"
#include "load.h"
#include "util.h"
#include "libpcp.h"

typedef struct PARSER {
    char	*yy_input;
    char	*yy_lexicon;
    int		yy_lexpeek;
    int		yy_error;
    sds		yy_errstr;
    char	*yy_tokbuf;
    int 	yy_tokbuflen;
    meta_t	yy_meta;
    sds		yy_base;
    node_t	*yy_np;
    series_t	yy_series;
} PARSER;

typedef union {
    sds		s;
    node_t	*n;
    meta_t	m;
} YYSTYPE;

#define YYSTYPE_IS_DECLARED 1
static int yylex(YYSTYPE *, PARSER *);
static int yyerror(PARSER *, const char *);

static int series_lex(YYSTYPE *, PARSER *);
static int series_error(PARSER *, const char *);
static void gramerr(PARSER *, const char *, const char *, char *);
static node_t *newnode(int);
static node_t *newmetric(char *);
static node_t *newmetricquery(char *, node_t *);
static node_t *newtree(int, node_t *, node_t *);
static void newaligntime(PARSER *, const char *);
static void newstarttime(PARSER *, const char *);
static void newinterval(PARSER *, const char *);
static void newendtime(PARSER *, const char *);
static void newrange(PARSER *, const char *);
static void newtimezone(PARSER *, const char *);
static void newsamples(PARSER *, const char *);
static void newoffset(PARSER *, const char *);
static char *n_type_str(int);
static char *n_type_c(int);
static char *l_type_str(int);

/* strings for error reporting */
static const char follow[]       = "follow";
//static const char bexpr_str[]    = "Boolean expression";
//static const char aexpr_str[]    = "Arithmetic expression";
static const char op_str[]       = "Arithmetic or relational or boolean operator";
static const char name_str[]     = "Symbol";
static const char unexpected_str[]       = "Unexpected";
static const char initial_str[]  = "Unexpected initial";

#line 143 "query_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "query_parser.tab.h".  */
#ifndef YY_YY_QUERY_PARSER_TAB_H_INCLUDED
# define YY_YY_QUERY_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    L_UNDEF = 258,
    L_ERROR = 259,
    L_EOS = 260,
    L_PLUS = 261,
    L_MINUS = 262,
    L_STAR = 263,
    L_SLASH = 264,
    L_COLON = 265,
    L_LPAREN = 266,
    L_RPAREN = 267,
    L_LBRACE = 268,
    L_RBRACE = 269,
    L_LSQUARE = 270,
    L_RSQUARE = 271,
    L_ABS = 272,
    L_FLOOR = 273,
    L_LOG = 274,
    L_SQRT = 275,
    L_ROUND = 276,
    L_AVG = 277,
    L_COUNT = 278,
    L_DELTA = 279,
    L_MAX = 280,
    L_MIN = 281,
    L_SUM = 282,
    L_ANON = 283,
    L_RATE = 284,
    L_INSTANT = 285,
    L_LT = 286,
    L_LEQ = 287,
    L_EQ = 288,
    L_GLOB = 289,
    L_GEQ = 290,
    L_GT = 291,
    L_NEQ = 292,
    L_REQ = 293,
    L_RNE = 294,
    L_AND = 295,
    L_OR = 296,
    L_MKCONST = 297,
    L_RESCALE = 298,
    L_DEFINED = 299,
    L_TYPE = 300,
    L_SEMANTICS = 301,
    L_UNITS = 302,
    L_ASSIGN = 303,
    L_COMMA = 304,
    L_INTERVAL = 305,
    L_TIMEZONE = 306,
    L_ALIGN = 307,
    L_START = 308,
    L_FINISH = 309,
    L_SAMPLES = 310,
    L_OFFSET = 311,
    EVENT_UNIT = 312,
    TIME_UNIT = 313,
    SPACE_UNIT = 314,
    L_INTEGER = 315,
    L_DOUBLE = 316,
    L_NAME = 317,
    L_STRING = 318,
    L_RANGE = 319
  };
#endif

/* Value type.  */



int yyparse (PARSER *lp);

#endif /* !YY_YY_QUERY_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 253 "query_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  42
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   631

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  17
/* YYNRULES -- Number of rules.  */
#define YYNRULES  130
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  339

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   319

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   188,   188,   189,   197,   202,   208,   210,   212,   218,
     223,   228,   235,   241,   244,   245,   248,   253,   260,   265,
     272,   273,   277,   278,   279,   283,   285,   287,   289,   291,
     293,   295,   297,   302,   304,   306,   308,   310,   312,   316,
     318,   320,   322,   326,   328,   335,   340,   348,   352,   359,
     364,   369,   374,   379,   384,   389,   407,   425,   430,   435,
     440,   445,   450,   455,   460,   465,   471,   477,   482,   487,
     492,   497,   502,   507,   514,   520,   526,   532,   538,   544,
     550,   556,   562,   568,   574,   580,   586,   592,   598,   604,
     613,   618,   623,   628,   633,   638,   643,   661,   679,   684,
     689,   694,   699,   705,   711,   716,   721,   726,   731,   736,
     741,   746,   751,   756,   761,   767,   773,   779,   785,   791,
     797,   803,   809,   815,   821,   827,   833,   839,   845,   851,
     857
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "L_UNDEF", "L_ERROR", "L_EOS", "L_PLUS",
  "L_MINUS", "L_STAR", "L_SLASH", "L_COLON", "L_LPAREN", "L_RPAREN",
  "L_LBRACE", "L_RBRACE", "L_LSQUARE", "L_RSQUARE", "L_ABS", "L_FLOOR",
  "L_LOG", "L_SQRT", "L_ROUND", "L_AVG", "L_COUNT", "L_DELTA", "L_MAX",
  "L_MIN", "L_SUM", "L_ANON", "L_RATE", "L_INSTANT", "L_LT", "L_LEQ",
  "L_EQ", "L_GLOB", "L_GEQ", "L_GT", "L_NEQ", "L_REQ", "L_RNE", "L_AND",
  "L_OR", "L_MKCONST", "L_RESCALE", "L_DEFINED", "L_TYPE", "L_SEMANTICS",
  "L_UNITS", "L_ASSIGN", "L_COMMA", "L_INTERVAL", "L_TIMEZONE", "L_ALIGN",
  "L_START", "L_FINISH", "L_SAMPLES", "L_OFFSET", "EVENT_UNIT",
  "TIME_UNIT", "SPACE_UNIT", "L_INTEGER", "L_DOUBLE", "L_NAME", "L_STRING",
  "L_RANGE", "$accept", "query", "vector", "exprlist", "exprval", "string",
  "number", "timelist", "timespec", "timeexpr", "expr", "val_vec",
  "sid_vec", "func_sid", "arithmetic_expr_sid", "func",
  "arithmetic_expression", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319
};
# endif

#define YYPACT_NINF -245

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-245)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     113,   -18,     3,    62,    75,   117,   126,   158,   176,   189,
     203,   209,   219,   114,   191,  -245,   614,   618,   288,  -245,
     322,  -245,  -245,  -245,    -1,   316,   103,   159,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,  -245,   -18,
     317,   128,  -245,   186,   186,   186,   186,   206,   206,   206,
     206,  -245,   206,   206,   206,   206,  -245,   186,   186,   186,
     186,   177,   -18,   568,    91,    91,   568,   568,    91,    91,
     568,   -18,   -18,   -18,   -18,   252,   210,   368,   376,   383,
     390,   397,   404,   411,    34,    72,   152,   230,   418,   425,
     432,   439,   446,   453,   460,   467,   474,   481,   488,   495,
     502,   509,   516,   523,   530,   537,   544,   551,   558,   565,
     572,   579,   586,   593,   600,   607,   263,   307,   311,   315,
      33,   104,   224,   256,   271,   300,   301,   334,  -245,    69,
    -245,   102,  -245,   262,   287,   314,   321,   335,   346,   347,
     348,   350,   351,   352,   265,   165,   201,   165,   201,  -245,
    -245,  -245,  -245,   354,   355,   367,   375,   382,   389,   396,
     403,   410,   417,   424,   332,   232,   236,   232,   236,  -245,
    -245,  -245,  -245,   232,   236,   232,   236,  -245,  -245,  -245,
    -245,   165,   201,   165,   201,  -245,  -245,  -245,  -245,  -245,
     317,   103,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,
    -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,   -18,   317,
    -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,    91,
    -245,    91,  -245,    91,  -245,    91,  -245,  -245,  -245,  -245,
    -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,
    -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,
    -245,  -245,  -245,  -245,   324,   331,   338,   345,   184,   214,
     359,   214,   214,   214,   319,   369,   431,   317,   186,   186,
     186,   186,   186,   186,   186,   186,   186,   186,   186,   -18,
     206,   206,   206,   206,   206,   206,   206,   206,   206,   206,
     206,   -18,    71,    55,    87,   430,   437,   438,   444,   445,
     451,   452,   458,  -245,   317,  -245,  -245,  -245,  -245,  -245,
    -245,  -245,  -245,  -245,  -245,  -245,  -245,    56,    57,   466,
     400,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,  -245,
     147,   400,  -245,  -245,   317,   472,   149,  -245,  -245
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    48,     0,     2,     0,     0,     0,    73,
       0,   114,    17,    16,     0,     0,    13,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     9,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,     0,
       0,    11,     0,     0,     0,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    48,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    32,     0,
      21,    48,     3,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   115,   116,   119,   120,   123,
     124,   127,   128,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    48,    74,    75,    78,    79,    82,
      83,    86,    87,    76,    77,    80,    81,    84,    85,    88,
      89,   117,   118,   121,   122,   125,   126,   129,   130,     7,
       0,    12,    18,    19,    41,    14,    15,    33,    34,    35,
      42,    36,    37,    38,    39,    40,    43,    44,     0,     0,
      98,    61,    62,    99,   100,    63,    64,   101,   104,     0,
      67,     0,    68,     0,   105,     0,   106,    69,    70,   107,
     108,    71,    72,   109,   112,    59,    60,   113,    92,    51,
      52,    93,    94,    53,    54,    95,   110,    57,    58,   111,
      90,    49,    50,    91,     0,     0,     0,     0,    47,     0,
       0,     0,     0,     0,     0,     0,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     4,     0,    23,    24,    22,    25,    26,
      29,    30,    31,    27,    28,     8,    20,     0,     0,     0,
      47,    46,   102,    65,    66,   103,    96,    55,    56,    97,
       0,     0,    47,     6,     0,    45,     0,     5,    45
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -245,  -245,   402,   -15,    46,   180,   -53,  -137,  -244,   211,
     121,    31,   -27,     2,  -245,    65,  -245
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    14,    15,    24,   194,    25,   196,   129,   308,   130,
      26,    16,    17,    18,    19,    20,    21
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint16 yytable[] =
{
      77,    81,    85,    89,    93,    97,   101,   105,   109,   113,
     117,   197,   198,    61,    27,   201,   202,   310,   311,   312,
     165,   167,   169,   171,   120,   173,   175,   177,   179,    78,
      82,    86,    90,    94,    98,   102,   106,   110,   114,   118,
      43,    44,    45,    46,    22,    23,   218,   258,    62,   166,
     168,   170,   172,   292,   174,   176,   178,   180,    76,    80,
      84,    88,    92,    96,   100,   104,   108,   112,   116,   320,
     331,   332,   294,    28,   145,   147,   149,   151,    47,    48,
      49,    50,    62,   219,   220,   266,    29,   319,   181,   183,
     185,   187,    79,    83,    87,    91,    95,    99,   103,   107,
     111,   115,   119,   321,    62,    62,    62,    38,   146,   148,
     150,   152,   199,   200,   259,    39,   203,    40,   267,    38,
     267,   221,   182,   184,   186,   188,     1,    39,    30,    40,
       2,     3,     4,     5,     6,     7,   267,    31,     8,     9,
      10,     1,    11,    73,    74,     2,     3,     4,     5,     6,
       7,   192,   193,     8,     9,    10,    12,    11,    52,    53,
      54,    55,    41,   335,   222,   338,   295,   330,   296,    32,
     297,    12,   298,    45,    46,    13,     2,     3,     4,     5,
       6,     7,   189,   191,     8,     9,    10,    33,    11,   303,
     131,    42,   190,   293,   206,   207,   267,   336,   267,   304,
      34,   223,    12,   133,   134,   135,   136,   137,   138,    59,
      60,   139,   140,   141,    35,   142,    43,    44,    45,    46,
      36,    75,   210,   153,   154,   155,   156,   157,   158,   143,
      37,   159,   160,   161,   260,   162,    57,    58,    59,    60,
      49,    50,   224,   195,    54,    55,   195,   195,   144,   163,
     195,   204,   205,    77,    81,    85,    89,    93,    97,   101,
     105,   109,   113,   117,   317,   208,   261,   209,   164,    43,
      44,    45,    46,   268,   305,   306,   318,   307,   279,   225,
     209,   262,    78,    82,    86,    90,    94,    98,   102,   106,
     110,   114,   118,    51,    52,    53,    54,    55,   269,    76,
      80,    84,    88,    92,    96,   100,   104,   108,   112,   116,
     263,   264,   254,    47,    48,    49,    50,    52,    53,    54,
      55,    57,    58,    59,    60,   270,    63,    56,    57,    58,
      59,    60,   271,    79,    83,    87,    91,    95,    99,   103,
     107,   111,   115,   119,   265,   291,   272,    64,    65,    66,
      67,    68,    69,    70,    71,    72,   255,   273,   274,   275,
     256,   276,   277,   278,   257,   280,   281,   121,   122,   123,
     124,   125,   126,   127,    47,    48,    49,    50,   282,   313,
     211,   128,    52,    53,    54,    55,   283,   299,   212,    57,
      58,    59,    60,   284,   300,   213,    43,    44,    45,    46,
     285,   301,   214,    47,    48,    49,    50,   286,   302,   215,
      52,    53,    54,    55,   287,   334,   216,    57,    58,    59,
      60,   288,   309,   217,    43,    44,    45,    46,   289,   314,
     226,    47,    48,    49,    50,   290,   315,   227,    52,    53,
      54,    55,   322,   132,   228,    57,    58,    59,    60,   323,
     324,   229,    43,    44,    45,    46,   325,   326,   230,    47,
      48,    49,    50,   327,   328,   231,    52,    53,    54,    55,
     329,   333,   232,    57,    58,    59,    60,   337,   316,   233,
      43,    44,    45,    46,     0,     0,   234,    47,    48,    49,
      50,     0,     0,   235,    52,    53,    54,    55,     0,     0,
     236,    57,    58,    59,    60,     0,     0,   237,    43,    44,
      45,    46,     0,     0,   238,    47,    48,    49,    50,     0,
       0,   239,    52,    53,    54,    55,     0,     0,   240,    57,
      58,    59,    60,     0,     0,   241,    43,    44,    45,    46,
       0,     0,   242,    47,    48,    49,    50,     0,     0,   243,
      52,    53,    54,    55,     0,     0,   244,    57,    58,    59,
      60,     0,     0,   245,    43,    44,    45,    46,     0,     0,
     246,    47,    48,    49,    50,     0,     0,   247,    52,    53,
      54,    55,     0,     0,   248,    57,    58,    59,    60,     0,
       0,   249,    43,    44,    45,    46,     0,     0,   250,    47,
      48,    49,    50,     0,     0,   251,    52,    53,    54,    55,
       0,     0,   252,    57,    58,    59,    60,     0,     0,   253,
      43,    44,    45,    46,    47,    48,    49,    50,   192,   193,
      22,    23
};

static const yytype_int16 yycheck[] =
{
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    64,    65,    14,    11,    68,    69,   261,   262,   263,
      47,    48,    49,    50,    39,    52,    53,    54,    55,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
       6,     7,     8,     9,    62,    63,    12,    14,    49,    47,
      48,    49,    50,   190,    52,    53,    54,    55,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    14,
      14,    14,   209,    11,    43,    44,    45,    46,     6,     7,
       8,     9,    49,    49,    12,    16,    11,    16,    57,    58,
      59,    60,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    16,    49,    49,    49,     5,    43,    44,
      45,    46,    66,    67,    10,    13,    70,    15,    49,     5,
      49,    49,    57,    58,    59,    60,    13,    13,    11,    15,
      17,    18,    19,    20,    21,    22,    49,    11,    25,    26,
      27,    13,    29,    40,    41,    17,    18,    19,    20,    21,
      22,    60,    61,    25,    26,    27,    43,    29,     6,     7,
       8,     9,    48,    16,    12,    16,   219,   304,   221,    11,
     223,    43,   225,     8,     9,    62,    17,    18,    19,    20,
      21,    22,     5,    62,    25,    26,    27,    11,    29,     5,
      62,     0,    15,   208,    73,    74,    49,   334,    49,    15,
      11,    49,    43,    17,    18,    19,    20,    21,    22,     8,
       9,    25,    26,    27,    11,    29,     6,     7,     8,     9,
      11,    62,    12,    17,    18,    19,    20,    21,    22,    43,
      11,    25,    26,    27,    10,    29,     6,     7,     8,     9,
       8,     9,    12,    63,     8,     9,    66,    67,    62,    43,
      70,    71,    72,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   289,   290,   279,    13,    10,    15,    62,     6,
       7,     8,     9,    11,    60,    61,   291,    63,    13,    49,
      15,    10,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,     5,     6,     7,     8,     9,    11,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
      10,    10,    49,     6,     7,     8,     9,     6,     7,     8,
       9,     6,     7,     8,     9,    11,    10,     5,     6,     7,
       8,     9,    11,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,    10,    13,    11,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    49,    11,    11,    11,
      49,    11,    11,    11,    49,    11,    11,    50,    51,    52,
      53,    54,    55,    56,     6,     7,     8,     9,    11,    60,
      12,    64,     6,     7,     8,     9,    11,    63,    12,     6,
       7,     8,     9,    11,    63,    12,     6,     7,     8,     9,
      11,    63,    12,     6,     7,     8,     9,    11,    63,    12,
       6,     7,     8,     9,    11,    15,    12,     6,     7,     8,
       9,    11,    63,    12,     6,     7,     8,     9,    11,    60,
      12,     6,     7,     8,     9,    11,     5,    12,     6,     7,
       8,     9,    12,    41,    12,     6,     7,     8,     9,    12,
      12,    12,     6,     7,     8,     9,    12,    12,    12,     6,
       7,     8,     9,    12,    12,    12,     6,     7,     8,     9,
      12,     5,    12,     6,     7,     8,     9,     5,   267,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,    -1,    -1,    12,     6,     7,     8,
       9,    -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,
      12,     6,     7,     8,     9,    -1,    -1,    12,     6,     7,
       8,     9,    -1,    -1,    12,     6,     7,     8,     9,    -1,
      -1,    12,     6,     7,     8,     9,    -1,    -1,    12,     6,
       7,     8,     9,    -1,    -1,    12,     6,     7,     8,     9,
      -1,    -1,    12,     6,     7,     8,     9,    -1,    -1,    12,
       6,     7,     8,     9,     6,     7,     8,     9,    60,    61,
      62,    63
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    13,    17,    18,    19,    20,    21,    22,    25,    26,
      27,    29,    43,    62,    66,    67,    76,    77,    78,    79,
      80,    81,    62,    63,    68,    70,    75,    11,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,     5,    13,
      15,    48,     0,     6,     7,     8,     9,     6,     7,     8,
       9,     5,     6,     7,     8,     9,     5,     6,     7,     8,
       9,    14,    49,    10,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    62,    76,    77,    78,    80,
      76,    77,    78,    80,    76,    77,    78,    80,    76,    77,
      78,    80,    76,    77,    78,    80,    76,    77,    78,    80,
      76,    77,    78,    80,    76,    77,    78,    80,    76,    77,
      78,    80,    76,    77,    78,    80,    76,    77,    78,    80,
      68,    50,    51,    52,    53,    54,    55,    56,    64,    72,
      74,    62,    67,    17,    18,    19,    20,    21,    22,    25,
      26,    27,    29,    43,    62,    76,    80,    76,    80,    76,
      80,    76,    80,    17,    18,    19,    20,    21,    22,    25,
      26,    27,    29,    43,    62,    77,    78,    77,    78,    77,
      78,    77,    78,    77,    78,    77,    78,    77,    78,    77,
      78,    76,    80,    76,    80,    76,    80,    76,    80,     5,
      15,    75,    60,    61,    69,    70,    71,    71,    71,    69,
      69,    71,    71,    69,    70,    70,    75,    75,    13,    15,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    49,
      12,    49,    12,    49,    12,    49,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
      12,    12,    12,    12,    49,    49,    49,    49,    14,    10,
      10,    10,    10,    10,    10,    10,    16,    49,    11,    11,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    13,
      11,    11,    11,    11,    11,    11,    11,    11,    11,    11,
      11,    13,    72,    68,    72,    71,    71,    71,    71,    63,
      63,    63,    63,     5,    15,    60,    61,    63,    73,    63,
      73,    73,    73,    60,    60,     5,    74,    68,    68,    16,
      14,    16,    12,    12,    12,    12,    12,    12,    12,    12,
      72,    14,    14,     5,    15,    16,    72,     5,    16
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    65,    66,    66,    67,    67,    67,    67,    67,    67,
      67,    67,    68,    68,    69,    69,    70,    70,    71,    71,
      72,    72,    73,    73,    73,    74,    74,    74,    74,    74,
      74,    74,    74,    75,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    76,    76,    77,    77,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    79,    79,    79,    79,    79,    79,
      79,    79,    79,    79,    79,    79,    79,    79,    79,    79,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    80,    80,    80,    80,    80,
      80,    80,    80,    80,    80,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     5,     8,     7,     4,     5,     2,
       2,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     4,     4,     1,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     4,     4,     4,
       4,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     6,     6,     4,     4,
       4,     4,     6,     6,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (lp, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, lp); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (lp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, PARSER *lp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, lp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, PARSER *lp)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , lp);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, lp); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, PARSER *lp)
{
  YYUSE (yyvaluep);
  YYUSE (lp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (PARSER *lp)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, lp);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 190 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_series.name = (yyvsp[-2].s);
		  (yyval.n) = lp->yy_series.expr;
		  YYACCEPT;
		}
#line 1617 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 198 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetricquery((yyvsp[-4].s), (yyvsp[-2].n));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1626 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 203 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetricquery((yyvsp[-7].s), (yyvsp[-5].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1636 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 209 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = lp->yy_series.expr = (yyvsp[-5].n); YYACCEPT; }
#line 1642 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 211 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = lp->yy_series.expr = (yyvsp[-2].n); YYACCEPT; }
#line 1648 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 213 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetric((yyvsp[-4].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1658 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 219 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetric((yyvsp[-1].s));
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1667 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 224 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1676 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 229 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		  YYACCEPT;
		}
#line 1685 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 236 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_AND);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_np;
		}
#line 1695 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 249 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STRING);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1704 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 254 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_NAME);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1713 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 261 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_INTEGER);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1722 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 266 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_DOUBLE);
		  lp->yy_np->value = sdsnew((yyvsp[0].s));
		  (yyval.n) = lp->yy_np;
		}
#line 1731 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 284 "query_parser.y" /* yacc.c:1646  */
    { newinterval(lp, (yyvsp[0].s)); }
#line 1737 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 286 "query_parser.y" /* yacc.c:1646  */
    { newtimezone(lp, (yyvsp[0].s)); }
#line 1743 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 288 "query_parser.y" /* yacc.c:1646  */
    { newsamples(lp, (yyvsp[0].s)); }
#line 1749 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 290 "query_parser.y" /* yacc.c:1646  */
    { newoffset(lp, (yyvsp[0].s)); }
#line 1755 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 292 "query_parser.y" /* yacc.c:1646  */
    { newaligntime(lp, (yyvsp[0].s)); }
#line 1761 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 294 "query_parser.y" /* yacc.c:1646  */
    { newstarttime(lp, (yyvsp[0].s)); }
#line 1767 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 296 "query_parser.y" /* yacc.c:1646  */
    { newendtime(lp, (yyvsp[0].s)); }
#line 1773 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 298 "query_parser.y" /* yacc.c:1646  */
    { newrange(lp, (yyvsp[0].s)); }
#line 1779 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 303 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_LT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1785 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 305 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_LEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1791 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 307 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_EQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1797 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 309 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_GEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1803 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 311 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_GT, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1809 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 313 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_NEQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1815 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 317 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_REQ, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1821 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 319 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_RNE, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1827 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 321 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1833 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 323 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_GLOB, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1839 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 327 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_AND, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1845 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 329 "query_parser.y" /* yacc.c:1646  */
    { (yyval.n) = lp->yy_np = newtree(N_OR, (yyvsp[-2].n), (yyvsp[0].n)); }
#line 1851 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 336 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetricquery((yyvsp[-6].s), (yyvsp[-4].n));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1860 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 341 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetric((yyvsp[-3].s));
		  lp->yy_np->time = lp->yy_series.time;
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1869 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 349 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetricquery((yyvsp[-3].s), (yyvsp[-1].n));
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1877 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 353 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newmetric((yyvsp[0].s)); /* TODO: perhaps newsidexpr()? */
                  (yyval.n) = lp->yy_series.expr = lp->yy_np;
                }
#line 1885 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 360 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1894 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 365 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1903 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 370 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1912 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 375 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1921 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 380 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1930 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 385 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1939 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 390 "query_parser.y" /* yacc.c:1646  */
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1961 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 408 "query_parser.y" /* yacc.c:1646  */
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1983 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 426 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 1992 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 431 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2001 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 436 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2010 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 441 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2019 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 446 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2028 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 451 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2037 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 456 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2046 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 461 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2055 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 466 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2065 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 472 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2075 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 478 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2084 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 483 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2093 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 488 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2102 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 493 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2111 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 498 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2120 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 503 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2129 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 508 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2137 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 515 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2147 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 521 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2157 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 527 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2167 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 533 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2177 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 539 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2187 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 545 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2197 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 551 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2207 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 557 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2217 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 563 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2227 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 569 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2237 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 575 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2247 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 581 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2257 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 587 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2267 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 593 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2277 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 599 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2287 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 605 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2297 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 614 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2306 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 619 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_RATE);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2315 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 624 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2324 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 629 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MAX);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2333 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 634 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2342 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 639 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MIN);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2351 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 644 "query_parser.y" /* yacc.c:1646  */
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2373 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 662 "query_parser.y" /* yacc.c:1646  */
    { double		mult;
		  struct pmUnits	units;
		  char			*errmsg;
		
		  lp->yy_np = newnode(N_RESCALE);
		  lp->yy_np->left = (yyvsp[-3].n);
		  if (pmParseUnitsStr((yyvsp[-1].s), &units, &mult, &errmsg) < 0) {
		      gramerr(lp, "Illegal units:", NULL, errmsg);
		      free(errmsg);
		      series_error(lp, NULL);
		      return -1;
		  }
		  lp->yy_np->right = newnode(N_SCALE);
		  lp->yy_np->right->meta.units = units;	/* struct assign */
		  lp->yy_np->right->value = (yyvsp[-1].s);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2395 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 680 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2404 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 685 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ABS);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2413 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 690 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2422 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 695 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_FLOOR);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2431 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 700 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2441 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 706 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-3].n);
		  lp->yy_np->right = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2451 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 712 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2460 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 717 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_LOG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2469 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 722 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2478 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 727 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SQRT);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2487 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 732 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2496 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 737 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_ROUND);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2505 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 742 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2514 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 747 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SUM);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2523 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 752 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2532 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 757 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_AVG);
		  lp->yy_np->left = (yyvsp[-1].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2541 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 762 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2549 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 768 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2559 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 774 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2569 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 780 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2579 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 786 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_PLUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2589 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 792 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2599 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 798 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2609 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 804 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2619 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 810 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_MINUS);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2629 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 816 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2639 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 822 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2649 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 828 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2659 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 834 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_STAR);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2669 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 840 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2679 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 846 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2689 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 852 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2699 "query_parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 858 "query_parser.y" /* yacc.c:1646  */
    { lp->yy_np = newnode(N_SLASH);
		  lp->yy_np->left = (yyvsp[-2].n);
		  lp->yy_np->right = (yyvsp[0].n);
		  (yyval.n) = lp->yy_series.expr = lp->yy_np;
		}
#line 2709 "query_parser.tab.c" /* yacc.c:1646  */
    break;


#line 2713 "query_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (lp, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (lp, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, lp);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, lp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (lp, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, lp);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, lp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 952 "query_parser.y" /* yacc.c:1906  */


/* function table for lexer */
static const struct {
    int		f_type;
    int		f_namelen;
    char	*f_name;
} func[] = {
    { L_AVG,		sizeof("avg")-1,	"avg" },
    { L_COUNT,		sizeof("count")-1,	"count" },
    { L_MAX,		sizeof("max")-1,	"max" },
    { L_MIN,		sizeof("min")-1,	"min" },
    { L_SUM,		sizeof("sum")-1,	"sum" },
    { L_RATE,		sizeof("rate")-1,	"rate" },
    { L_ABS,		sizeof("abs")-1,	"abs" },
    { L_FLOOR,		sizeof("floor")-1,	"floor" },
    { L_LOG,		sizeof("log")-1,	"log" },
    { L_SQRT,		sizeof("sqrt")-1,	"sqrt" },
    { L_ROUND,		sizeof("round")-1,	"round" },
    { L_RESCALE,	sizeof("rescale")-1,	"rescale" },
    { L_UNDEF,		0,			NULL }
};

static struct {
    int         ltype;
    int         ntype;
    char        *long_name;
    char        *short_name;
} typetab[] = {
    { L_UNDEF,		0,		"UNDEF",	NULL },
    { L_ERROR,		0,		"ERROR",	NULL },
    { L_EOS,		0,		"EOS",		NULL },
    { L_INTEGER,	N_INTEGER,	"INTEGER",	NULL },
    { L_DOUBLE,		N_DOUBLE,	"DOUBLE",	NULL },
    { L_NAME,		N_NAME,		"NAME",		NULL },
    { L_NAME,		N_METRIC,	"METRIC",	NULL },
    { L_NAME,		N_QUERY,	"QUERY",	NULL },
    { L_PLUS,		N_PLUS,		"PLUS",		"+" },
    { L_MINUS,		N_MINUS,	"MINUS",	"-" },
    { L_STAR,		N_STAR,		"STAR",		"*" },
    { L_SLASH,		N_SLASH,	"SLASH",	"/" },
    { L_LPAREN,		0,		"LPAREN",	"(" },
    { L_RPAREN,		0,		"RPAREN",	")" },
    { L_LBRACE,		0,		"LBRACE",	"{" },
    { L_RBRACE,		0,		"RBRACE",	"}" },
    { L_TYPE,		0,		"TYPE",		NULL },
    { L_SEMANTICS,	0,		"SEMANTICS",	NULL },
    { L_UNITS,		0,		"UNITS",	NULL },
    { L_ASSIGN,		0,		"ASSIGN",	"=" },
    { L_COMMA,		0,		"COMMA",	"," },
    { L_STRING,		0,		"STRING",	"\"" },
    { L_ABS,		N_ABS,		"ABS",		NULL },
    { L_FLOOR,		N_FLOOR,	"FLOOR",	NULL },
    { N_LOG,		N_LOG,		"LOG",		NULL },
    { N_SQRT,		N_SQRT,		"SQRT",		NULL },
    { N_ROUND,		N_ROUND,	"ROUND",	NULL },
    { L_AVG,		N_AVG,		"AVG",		NULL },
    { L_COUNT,		N_COUNT,	"COUNT",	NULL },
    { L_DELTA,		N_DELTA,	"DELTA",	NULL },
    { L_MAX,		N_MAX,		"MAX",		NULL },
    { L_MIN,		N_MIN,		"MIN",		NULL },
    { L_SUM,		N_SUM,		"SUM",		NULL },
    { L_ANON,		N_ANON,		"ANON",		NULL },
    { L_RATE,		N_RATE,		"RATE",		NULL },
    { L_INSTANT,	N_INSTANT,	"INSTANT",	NULL },
    { L_MKCONST,	0,		"MKCONST",	NULL },
    { L_RESCALE,	N_RESCALE,	"RESCALE",	NULL },
    { 0,		N_SCALE,	"SCALE",	NULL },
    { L_DEFINED,	N_DEFINED,	"DEFINED",	NULL },
    { L_INTERVAL,	N_INTERVAL,	"INTERVAL",	NULL },
    { L_START,		N_START,	"START",	NULL },
    { L_FINISH,		N_FINISH,	"FINISH",	NULL },
    { L_TIMEZONE,	N_TIMEZONE,	"TIMEZONE",	"TZ" },
    { L_SAMPLES,	N_SAMPLES,	"SAMPLES",	NULL },
    { L_OFFSET,		N_OFFSET,	"OFFSET",	NULL },
    { L_LT,		N_LT,		"LT",		"<" },
    { L_LEQ,		N_LEQ,		"LEQ",		"<=" },
    { L_EQ,		N_EQ,		"EQ",		"==" },
    { L_GLOB,		N_GLOB,		"GLOB",		"~~" },
    { L_GEQ,		N_GEQ,		"GEQ",		">=" },
    { L_GT,		N_GT,		"GT",		">" },
    { L_NEQ,		N_NEQ,		"NEQ",		"!=" },
    { L_REQ,		N_REQ,		"REQ",		"=~" },
    { L_RNE,		N_RNE,		"RNE",		"!~" },
    { L_AND,		N_AND,		"AND",		"&&" },
    { L_OR,		N_OR,		"OR",		"||" },
    { 0,		N_NEG,		"NEG",		"-" },
    { -1,		-1,		NULL,		NULL }
};

/* full name for all node types */
static char *
n_type_str(int type)
{
    int		i;
    static char n_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].long_name;
    pmsprintf(n_eh_str, sizeof(n_eh_str), "unknown type %d!", type);
    return n_eh_str;
}

/* short string for the operator node types */
static char *
n_type_c(int type)
{
    int		i;
    static char n_eh_c[20]; /* big enough for "op XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ntype != -1; i++)
	if (type == typetab[i].ntype)
	    return typetab[i].short_name;
    pmsprintf(n_eh_c, sizeof(n_eh_c), "op %d!", type);
    return n_eh_c;
}

/* full name for all lex types */
static char *
l_type_str(int type)
{
    int		i;
    static char l_eh_str[32];	/* big enough for "unknown type XXXXXXXXXXX!" */

    for (i = 0; typetab[i].ltype != -1; i++)
	if (type == typetab[i].ltype)
	    return typetab[i].long_name;
    pmsprintf(l_eh_str, sizeof(l_eh_str), "unknown type %d!", type);
    return l_eh_str;
}

static node_t *
newnode(int type)
{
    node_t	*np;

    if ((np = (node_t *)calloc(1, sizeof(node_t))) == NULL) {
	pmNoMem("pmSeries: newnode", sizeof(node_t), PM_FATAL_ERR);
	/*NOTREACHED*/
    }
    np->type = type;
    return np;
}

static node_t *
newtree(int type, node_t *left, node_t *right)
{
    node_t	*tree = newnode(type);

    tree->left = left;
    tree->right = right;
    return tree;
}

static node_t *
newmetric(char *name)
{
    node_t	*node;
    char	*re;

    /* enable globbing if string contains a non-escaped '*' */
    if ((re = strchr(name, '*')) != NULL &&
	(re == name || (re[-1] != '%' && re[-1] != '\\')))
	node = newnode(N_GLOB);
    else
	node = newnode(N_EQ);

    node->left = newnode(N_NAME);
    node->left->value = sdsnew("metric.name");
    node->right = newnode(N_STRING);
    node->right->value = sdsnew(name);
    return node;
}

static node_t *
newmetricquery(char *name, node_t *query)
{
    node_t	*root = newnode(N_AND);
    node_t	*metric = newmetric(name);

    root->left = metric;
    root->right = query;
    return root;
}

static void
newinterval(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->delta, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time delta with pmParseInterval:\n%s", error);
	free(error);
    } else {
	tp->window.delta = sdsnew(string);
    }
}

static void
parsetime(PARSER *lp, struct timeval *result, const char *string)
{
    struct timeval start = { 0, 0 };
    struct timeval end = { INT_MAX, 0 };
    char	*error;
    int		sts;

    if ((sts = __pmParseTime(string, &start, &end, result, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse time with __pmParseTime:\n%s", error);
	free(error);
    }
}

static void
newstarttime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->start, string);
    if (!lp->yy_error)
	tp->window.start = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "START: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (start: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newendtime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->end, string);
    if (!lp->yy_error)
	tp->window.end = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "END: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (end: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newrange(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	*error;
    int		sts;

    if ((sts = pmParseInterval(string, &tp->start, &error)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse range with pmParseInterval:\n%s", error);
	lp->yy_error = sts;
	free(error);
    } else {
	struct timeval offset;
	gettimeofday(&offset, NULL);
	tsub(&offset, &tp->start);
	tp->start = offset;
	tp->end.tv_sec = INT_MAX;
	tp->window.range = sdsnew(string);
    }
}

static void
newaligntime(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;

    parsetime(lp, &tp->align, string);
    if (!lp->yy_error)
	tp->window.align = sdsnew(string);
#if 0
    if (!lp->yy_error)
fprintf(stderr, "ALIGN: %.64g\n", pmtimevalToReal(result));
    else
fprintf(stderr, "ERROR (align: %s): %s\n", string, lp->yy_errstr);
#endif
}

static void
newtimezone(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    char	e[PM_MAXERRMSGLEN];
    int		sts;

    if ((sts = pmNewZone(string)) < 0) {
	lp->yy_error = sts;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Cannot parse timezone with pmNewZone:\n\"%s\" - %s",
		string, pmErrStr_r(sts, e, sizeof(e)));
    } else {
	tp->zone = sts;
	tp->window.zone = sdsnew(string);
    }
}

static void
newsamples(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample count requested - \"%s\"", string);
    } else {
	tp->count = sts;
	tp->window.count = sdsnew(string);
    }
}

static void
newoffset(PARSER *lp, const char *string)
{
    timing_t	*tp = &lp->yy_series.time;
    int		sts;

    if ((sts = atoi(string)) < 0) {
	lp->yy_error = -EINVAL;
	lp->yy_errstr = sdscatfmt(sdsempty(),
		"Invalid sample offset requested - \"%s\"", string);
    } else {
	tp->offset = sts;
	tp->window.offset = sdsnew(string);
    }
}

static void
gramerr(PARSER *lp, const char *phrase, const char *pos, char *arg)
{
   char errmsg[256];

   /* unless lexer has already found something amiss ... */
   if (lp->yy_errstr == NULL) {
	if (pos == NULL)
	    pmsprintf(errmsg, sizeof(errmsg), "%s '%s'", phrase, arg);
	else
	    pmsprintf(errmsg, sizeof(errmsg), "%s expected to %s %s", phrase, pos, arg);
	lp->yy_errstr = sdsnew(errmsg);
   }
}

/* Construct error message buffer for syntactic error */
static char *
parseError(const char *spec, const char *point, const char *msg)
{
    size_t	need = 2 * strlen(spec) + strlen(msg) + 8;
    const char	*p;
    char	*q, *result;

    if ((result = malloc(need)) == NULL)
	return NULL;
    q = result;

    for (p = spec; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    for (p = spec; p != point; p++)
	*q++ = isgraph((int)*p) ? ' ' : *p;
    snprintf(q, need - (q - result), "^ -- ");
    q += 5;
    for (p = msg; *p != '\0'; p++)
	*q++ = *p;
    *q++ = '\n';
    *q = '\0';
    return result;
}

static int
series_error(PARSER *lp, const char *s)
{
    char	*msg;

    msg = parseError(lp->yy_base, lp->yy_lexicon, s ? s : "syntax error");
    lp->yy_errstr = sdscatfmt(sdsempty(), "cannot parse given string\n\n%s", msg);
    free(msg);

    lp->yy_series.expr = NULL;
    lp->yy_error = -EINVAL;
    return 0;
}

static int
yyerror(PARSER *lp, const char *s)
{
    return series_error(lp, s);
}

static void
unget(PARSER *lp, int c)
{
    lp->yy_lexpeek = c;
}

static int
get(PARSER *lp)
{
    int		c;

    if (lp->yy_lexpeek != 0) {
	c = lp->yy_lexpeek;
	lp->yy_lexpeek = 0;
	return c;
    }
    c = *lp->yy_input;
    if (c == '\0')
	return EOF;
    lp->yy_input++;
    return c;
}

static int
series_lex(YYSTYPE *lvalp, PARSER *lp)
{
    char	*p = lp->yy_tokbuf;
    int		ltype = L_UNDEF;
    int		c, i, len;
    int		firstch = 1;
    int		ret = L_UNDEF;

    for ( ; ret == L_UNDEF; ) {
	c = get(lp);
	if (firstch) {
	    if (isspace((int)c)) continue;
	    lp->yy_lexicon = &lp->yy_input[-1];
	    firstch = 0;
	}
	if (c == EOF) {
	    if (ltype != L_UNDEF) {
		/* force end of last token */
		c = 0;
	    }
	    else {
		/* really the end of the input buffer */
		ret = L_EOS;
		break;
	    }
	}
	if (p == NULL) {
	    lp->yy_tokbuflen = 128;
	    if ((p = (char *)malloc(lp->yy_tokbuflen)) == NULL) {
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot allocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	}
	else if (p >= &lp->yy_tokbuf[lp->yy_tokbuflen]) {
	    len = p - lp->yy_tokbuf;
	    lp->yy_tokbuflen *= 2;
	    if (!(p = (char *)realloc(lp->yy_tokbuf, lp->yy_tokbuflen))) {
		lp->yy_errstr = sdscatfmt(sdsempty(),
				"cannot reallocate token buffer (length=%lld)",
				(long long)lp->yy_tokbuflen);
		lp->yy_error = -ENOMEM;
		ret = L_ERROR;
		break;
	    }
	    lp->yy_tokbuf = p;
	    p = &lp->yy_tokbuf[len];
	}

	*p++ = (char)c;

	if (ltype == L_UNDEF) {
	    if (isdigit((int)c))
		ltype = L_INTEGER;
	    else if (c == '.')
		ltype = L_DOUBLE;
	    else if (isalpha((int)c))
		ltype = L_NAME;
	    else {
		switch (c) {
		    case '+':
			*p = '\0';
			ret = L_PLUS;
			break;

		    case '-':
			*p = '\0';
			ret = L_MINUS;
			break;

		    case '*':
			*p = '\0';
			ret = L_STAR;
			break;

		    case '/':
			*p = '\0';
			ret = L_SLASH;
			break;

		    case '(':
			*p = '\0';
			ret = L_LPAREN;
			break;

		    case ')':
			*p = '\0';
			ret = L_RPAREN;
			break;

		    case '{':
			*p = '\0';
			ret = L_LBRACE;
			break;

		    case '}':
			*p = '\0';
			ret = L_RBRACE;
			break;

		    case '[':
			*p = '\0';
			ret = L_LSQUARE;
			break;

		    case ']':
			*p = '\0';
			ret = L_RSQUARE;
			break;

		    case '<':
			ltype = L_LT;
			break;

		    case '=':
			ltype = L_EQ;
			break;

		    case '~':
			ltype = L_GLOB;
			break;

		    case '>':
			ltype = L_GT;
			break;

		    case '!':
			ltype = L_NEQ;
			break;

		    case '&':
			ltype = L_AND;
			break;

		    case '|':
			ltype = L_OR;
			break;

		    case ':':
			*p = '\0';
			ret = L_COLON;
			break;

		    case ',':
			*p = '\0';
			ret = L_COMMA;
			break;

		    case '"':
			ltype = L_STRING;
			break;

		    default:
			*p = '\0';
			lp->yy_errstr = sdsnew("Illegal character");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		}
	    }
	}
	else {
	    if (ltype == L_INTEGER) {
		if (c == '.') {
		    ltype = L_DOUBLE;
		}
		else if (isalpha((int)c)) {
		    ltype = L_RANGE;
		}
		else if (!isdigit((int)c)) {
		    char	*endptr;
		    __uint64_t	check;

		    unget(lp, c);
		    p[-1] = '\0';
		    check = strtoull(lp->yy_tokbuf, &endptr, 10);
		    if (*endptr != '\0' || check > 0xffffffffUL) {
			lp->yy_errstr = sdsnew("Constant value too large");
			lp->yy_error = -EINVAL;
			ret = L_ERROR;
			break;
		    }
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for INTEGER failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_INTEGER;
		    break;
		}
	    }
	    else if (ltype == L_RANGE) {
		if (!isalpha((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for RANGE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_RANGE;
		    break;
		}
	    }
	    else if (ltype == L_DOUBLE) {
		if (!isdigit((int)c)) {
		    unget(lp, c);
		    p[-1] = '\0';
		    if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
			lp->yy_errstr = sdsnew("dup() for DOUBLE failed");
			lp->yy_error = -ENOMEM;
			ret = L_ERROR;
			break;
		    }
		    ret = L_DOUBLE;
		    break;
		}
	    }
	    else if (ltype == L_NAME) {
		if (isalpha((int)c) || isdigit((int)c) ||
		    c == '_' || c == '.' || c == '*' || c == '%' || c == '\\')
		    continue;
		if (c == '(') {
		    /* check for functions ... */
		    len = p - lp->yy_tokbuf - 1;
		    for (i = 0; func[i].f_name != NULL; i++) {
			if (len == func[i].f_namelen &&
			    strncmp(lp->yy_tokbuf, func[i].f_name, len) == 0) {
			    unget(lp, c);
			    p[-1] = '\0';
			    ret = func[i].f_type;
			    break;
			}
		    }
		    if (func[i].f_name != NULL) {
			/* match func name */
			break;
		    }
		}

		/* current character is end of name */
		unget(lp, c);
		p[-1] = '\0';
		if (strcmp(lp->yy_tokbuf, "type") == 0) {
		    ret = L_TYPE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "semantics") == 0) {
		    ret = L_SEMANTICS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "units") == 0) {
		    ret = L_UNITS;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "interval") == 0 ||
			 strcmp(lp->yy_tokbuf, "delta") == 0) {
		    ret = L_INTERVAL;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "timezone") == 0 ||
			 strcmp(lp->yy_tokbuf, "tz") == 0) {
		    ret = L_TIMEZONE;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "start") == 0 ||
			 strcmp(lp->yy_tokbuf, "begin") == 0) {
		    ret = L_START;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "finish") == 0 ||
			 strcmp(lp->yy_tokbuf, "end") == 0) {
		    ret = L_FINISH;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "samples") == 0 ||
			 strcmp(lp->yy_tokbuf, "count") == 0) {
		    ret = L_SAMPLES;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "offset") == 0 ||
			 strcmp(lp->yy_tokbuf, "from") == 0) {
		    ret = L_OFFSET;
		    break;
		}
		else if (strcmp(lp->yy_tokbuf, "align") == 0 ||
			 strcmp(lp->yy_tokbuf, "alignment") == 0) {
		    ret = L_ALIGN;
		    break;
		}
		if ((lvalp->s = sdsnew(lp->yy_tokbuf)) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for NAME failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_NAME;
		break;
	    }
	    else if (ltype == L_STRING) {
		if (c != '"')
		    continue;
		/* [-1] and [1] to strip quotes */
		p[-1] = '\0';
		if ((lvalp->s = sdsnew(&lp->yy_tokbuf[1])) == NULL) {
		    lp->yy_errstr = sdsnew("dup() for STRING failed");
		    lp->yy_error = -ENOMEM;
		    ret = L_ERROR;
		    break;
		}
		ret = L_STRING;
		break;
	    }
	    else if (ltype == L_LT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_LEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_LT;
		    break;
		}
	    }
	    else if (ltype == L_GT) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_GEQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_GT;
		    break;
		}
	    }
	    else if (ltype == L_GLOB) {
		if (c == '~') {
		    *p = '\0';
		    ret = L_GLOB;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_EQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_EQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_REQ;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    ret = L_ASSIGN;
		    break;
		}
	    }
	    else if (ltype == L_NEQ) {
		if (c == '=') {
		    *p = '\0';
		    ret = L_NEQ;
		    break;
		}
		else if (c == '~') {
		    *p = '\0';
		    ret = L_RNE;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_AND) {
		if (c == '&') {
		    *p = '\0';
		    ret = L_AND;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	    else if (ltype == L_OR) {
		if (c == '|') {
		    *p = '\0';
		    ret = L_OR;
		    break;
		}
		else {
		    unget(lp, c);
		    p[-1] = '\0';
		    lp->yy_errstr = sdsnew("Illegal character");
		    lp->yy_error = -EINVAL;
		    ret = L_ERROR;
		    break;
		}
	    }
	}
    }

    if (pmDebugOptions.series && pmDebugOptions.appl0)
	fprintf(stderr, "series_lex() -> type=L_%s \"%s\"\n",
		l_type_str(ret), ret == L_EOS ? "" : lp->yy_tokbuf);

    return ret;
}

static int
yylex(YYSTYPE *lvalp, PARSER *lp)
{
    return series_lex(lvalp, lp);
}

static void
series_dumpexpr(node_t *np, int level)
{
    if (np == NULL)
	return;

    series_dumpexpr(np->left, level+1);

    switch (np->type) {
    case N_NAME: case N_INTEGER: case N_DOUBLE:
	fprintf(stderr, "%*s%s", level*4, "", np->value);
	break;
    case N_STRING:
	fprintf(stderr, "%*s\"%s\"", level*4, "", np->value);
	break;
    case N_LT:  case N_LEQ: case N_EQ:  case N_GEQ: case N_GT:  case N_NEQ:
    case N_AND: case N_OR:  case N_RNE: case N_REQ: case N_NEG: case N_GLOB:
    case N_PLUS: case N_MINUS: case N_STAR: case N_SLASH:
	fprintf(stderr, "%*s%s", level*4, "", n_type_c(np->type));
	break;
    case N_AVG: case N_COUNT:   case N_DELTA:   case N_MAX:     case N_MIN:
    case N_SUM: case N_ANON:    case N_RATE:    case N_INSTANT: case N_RESCALE:
	fprintf(stderr, "%*s%s()", level*4, "", n_type_str(np->type));
	break;
    case N_SCALE: {
	char	strbuf[60];

	if (pmUnitsStr_r(&np->meta.units, strbuf, sizeof(strbuf)) == NULL)
	    fprintf(stderr, " [bad units: %d %d %d %d %d %d]",
			np->meta.units.scaleCount, np->meta.units.scaleTime,
			np->meta.units.scaleSpace,
			np->meta.units.dimCount, np->meta.units.dimTime,
			np->meta.units.dimSpace);
	else
	    fprintf(stderr, " [%s]", strbuf);
	break;
	}
    default:
	break;
    }
    fputc('\n', stderr);

    series_dumpexpr(np->right, level+1);
}

int
series_parse(sds query, series_t *sp, char **err, void *arg)
{
    PARSER	yp = { .yy_base = query, .yy_input = (char *)query };
    series_t	*ypsp = &yp.yy_series;
    int		sts;

    if ((sts = yyparse(&yp)) != 0) {
	*err = yp.yy_errstr;
	return yp.yy_error;
    }

    if (ypsp->expr == NULL) {
	if (pmDebugOptions.series || pmDebugOptions.query)
	    fprintf(stderr, "Error: parsing query '%s'\n", query);
	return PM_ERR_NYI;
    }

    if (pmDebugOptions.query) {
	fprintf(stderr, "parsed query: %s\n", query);
	series_dumpexpr(ypsp->expr, 0);
	fputc('\n', stderr);
    }

    *sp = *ypsp;
    return sts;
}

int
pmSeriesQuery(pmSeriesSettings *settings, sds query, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    char	*errstr;
    int		sts;

    if ((sts = series_parse(query, &sp, &errstr, arg)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
    	return sts;
    }

    if (sp.expr == NULL) {
	if (pmDebugOptions.series || pmDebugOptions.query)
	    fprintf(stderr, "Error: parsing query '%s'\n", query);
	return PM_ERR_NYI;
    }

    return series_solve(settings, sp.expr, &sp.time, flags, arg);
}

int
pmSeriesLoad(pmSeriesSettings *settings, sds source, pmSeriesFlags flags, void *arg)
{
    series_t	sp = {0};
    char	*errstr;
    int		sts;

    if ((sts = series_parse(source, &sp, &errstr, arg)) != 0) {
	moduleinfo(&settings->module, PMLOG_ERROR, errstr, arg);
    	return sts;
    }

    if (sp.expr == NULL) {
	if (pmDebugOptions.series || pmDebugOptions.query)
	    fprintf(stderr, "Error: parsing query '%s'\n", source);
	return PM_ERR_NYI;
    }

    if (pmDebugOptions.query) {
	fprintf(stderr, "pmSeriesLoad: %s\n", source);
	series_dumpexpr(sp.expr, 0);
	fputc('\n', stderr);
    }

    return series_load(settings, sp.expr, &sp.time, flags, arg);
}
