/*
 * Performance Metrics Name Space Map
 * Built by pmgenmap.sh from the file
 * systmetrics.map
 * on Tue Dec 22 18:55:46 UTC 2020
 *
 * Do not edit this file!
 */

/*
 *
 * metric names and access macros for photosyst.[ch]
 *
 */

const char *systmetrics[] = {
/* /proc/loadavg */
#define CPU_LOAD	0
	"kernel.all.load",

/* /proc/stat */
#define CPU_CSW	1
	"kernel.all.pswitch",
#define CPU_DEVINT	2
	"kernel.all.intr",
#define CPU_NPROCS	3
	"kernel.all.sysfork",
#define CPU_BTIME	4
	"kernel.all.boottime",
#define CPU_UTIME	5
	"kernel.all.cpu.user",
#define CPU_NTIME	6
	"kernel.all.cpu.nice",
#define CPU_STIME	7
	"kernel.all.cpu.sys",
#define CPU_ITIME	8
	"kernel.all.cpu.idle",
#define CPU_WTIME	9
	"kernel.all.cpu.wait.total",
#define CPU_HARDIRQ	10
	"kernel.all.cpu.irq.hard",
#define CPU_SOFTIRQ	11
	"kernel.all.cpu.irq.soft",
#define CPU_STEAL	12
	"kernel.all.cpu.steal",
#define CPU_GUEST	13
	"kernel.all.cpu.guest",
#define PERCPU_STIME	14
	"kernel.percpu.cpu.sys",
#define PERCPU_UTIME	15
	"kernel.percpu.cpu.user",
#define PERCPU_NTIME	16
	"kernel.percpu.cpu.nice",
#define PERCPU_ITIME	17
	"kernel.percpu.cpu.idle",
#define PERCPU_WTIME	18
	"kernel.percpu.cpu.wait.total",
#define PERCPU_HARDIRQ	19
	"kernel.percpu.cpu.irq.hard",
#define PERCPU_SOFTIRQ	20
	"kernel.percpu.cpu.irq.soft",
#define PERCPU_STEAL	21
	"kernel.percpu.cpu.steal",
#define PERCPU_GUEST	22
	"kernel.percpu.cpu.guest",

#define PERCPU_FREQCNT_CNT	23
	"hinv.cpu.clock",

/* /proc/vmstat */
#define MEM_SWINS	24
	"swap.pagesin",
#define MEM_SWOUTS	25
	"swap.pagesout",
#define MEM_SCAN_DDMA	26
	"mem.vmstat.pgscan_direct_dma",
#define MEM_SCAN_DDMA32	27
	"mem.vmstat.pgscan_direct_dma32",
#define MEM_SCAN_DHIGH	28
	"mem.vmstat.pgscan_direct_high",
#define MEM_SCAN_DMOVABLE	29
	"mem.vmstat.pgscan_direct_movable",
#define MEM_SCAN_DNORMAL	30
	"mem.vmstat.pgscan_direct_normal",
#define MEM_SCAN_KDMA	31
	"mem.vmstat.pgscan_kswapd_dma",
#define MEM_SCAN_KDMA32	32
	"mem.vmstat.pgscan_kswapd_dma32",
#define MEM_SCAN_KHIGH	33
	"mem.vmstat.pgscan_kswapd_high",
#define MEM_SCAN_KMOVABLE	34
	"mem.vmstat.pgscan_kswapd_movable",
#define MEM_SCAN_KNORMAL	35
	"mem.vmstat.pgscan_kswapd_normal",
#define MEM_STEAL_DMA	36
	"mem.vmstat.pgsteal_dma",
#define MEM_STEAL_DMA32	37
	"mem.vmstat.pgsteal_dma32",
#define MEM_STEAL_HIGH	38
	"mem.vmstat.pgsteal_high",
#define MEM_STEAL_MOVABLE	39
	"mem.vmstat.pgsteal_movable",
#define MEM_STEAL_NORMAL	40
	"mem.vmstat.pgsteal_normal",
#define MEM_ALLOCSTALL	41
	"mem.vmstat.allocstall",

/* /proc/meminfo */
#define MEM_CACHEMEM	42
	"mem.util.cached",
#define MEM_CACHEDRT	43
	"mem.util.dirty",
#define MEM_PHYSMEM	44
	"mem.physmem",
#define MEM_FREEMEM	45
	"mem.freemem",
#define MEM_BUFFERMEM	46
	"mem.util.bufmem",
#define MEM_SHMEM	47
	"mem.util.shmem",
#define MEM_TOTSWAP	48
	"swap.length",
#define MEM_FREESWAP	49
	"swap.free",
#define MEM_SLABMEM	50
	"mem.util.slab",
#define MEM_SLABRECLAIM	51
	"mem.util.slabReclaimable",
#define MEM_COMMITTED	52
	"mem.util.committed_AS",
#define MEM_COMMITLIM	53
	"mem.util.commitLimit",
#define MEM_TOTHUGEPAGE	54
	"mem.util.hugepagesTotal",
#define MEM_FREEHUGEPAGE	55
	"mem.util.hugepagesFree",
#define HUGEPAGESZ	56
	"hinv.hugepagesize",

/* shmctl(2) */
#define MEM_SHMRSS	57
	"ipc.shm.rss",
#define MEM_SHMSWP	58
	"ipc.shm.swp",

/* /proc/net/dev */
#define PERINTF_RBYTE	59
	"network.interface.in.bytes",
#define PERINTF_RPACK	60
	"network.interface.in.packets",
#define PERINTF_RERRS	61
	"network.interface.in.errors",
#define PERINTF_RDROP	62
	"network.interface.in.drops",
#define PERINTF_RFIFO	63
	"network.interface.in.fifo",
#define PERINTF_RFRAME	64
	"network.interface.in.frame",
#define PERINTF_RCOMPR	65
	"network.interface.in.compressed",
#define PERINTF_RMULTIC	66
	"network.interface.in.mcasts",
#define PERINTF_SBYTE	67
	"network.interface.out.bytes",
#define PERINTF_SPACK	68
	"network.interface.out.packets",
#define PERINTF_SERRS	69
	"network.interface.out.errors",
#define PERINTF_SDROP	70
	"network.interface.out.drops",
#define PERINTF_SFIFO	71
	"network.interface.out.fifo",
#define PERINTF_SCOLLIS	72
	"network.interface.collisions",
#define PERINTF_SCARRIER	73
	"network.interface.out.carrier",
#define PERINTF_SCOMPR	74
	"network.interface.out.compressed",

/* /proc/net/snmp */
#define IPV4_Forwarding	75
	"network.ip.forwarding",
#define IPV4_DefaultTTL	76
	"network.ip.defaultttl",
#define IPV4_InReceives	77
	"network.ip.inreceives",
#define IPV4_InHdrErrors	78
	"network.ip.inhdrerrors",
#define IPV4_InAddrErrors	79
	"network.ip.inaddrerrors",
#define IPV4_ForwDatagrams	80
	"network.ip.forwdatagrams",
#define IPV4_InUnknownProtos	81
	"network.ip.inunknownprotos",
#define IPV4_InDiscards	82
	"network.ip.indiscards",
#define IPV4_InDelivers	83
	"network.ip.indelivers",
#define IPV4_OutRequests	84
	"network.ip.outrequests",
#define IPV4_OutDiscards	85
	"network.ip.outdiscards",
#define IPV4_OutNoRoutes	86
	"network.ip.outnoroutes",
#define IPV4_ReasmTimeout	87
	"network.ip.reasmtimeout",
#define IPV4_ReasmReqds	88
	"network.ip.reasmreqds",
#define IPV4_ReasmOKs	89
	"network.ip.reasmoks",
#define IPV4_ReasmFails	90
	"network.ip.reasmfails",
#define IPV4_FragOKs	91
	"network.ip.fragoks",
#define IPV4_FragFails	92
	"network.ip.fragfails",
#define IPV4_FragCreates	93
	"network.ip.fragcreates",
#define ICMP4_InMsgs	94
	"network.icmp.inmsgs",
#define ICMP4_InErrors	95
	"network.icmp.inerrors",
#define ICMP4_InDestUnreachs	96
	"network.icmp.indestunreachs",
#define ICMP4_InTimeExcds	97
	"network.icmp.intimeexcds",
#define ICMP4_InParmProbs	98
	"network.icmp.inparmprobs",
#define ICMP4_InSrcQuenchs	99
	"network.icmp.insrcquenchs",
#define ICMP4_InRedirects	100
	"network.icmp.inredirects",
#define ICMP4_InEchos	101
	"network.icmp.inechos",
#define ICMP4_InEchoReps	102
	"network.icmp.inechoreps",
#define ICMP4_InTimestamps	103
	"network.icmp.intimestamps",
#define ICMP4_InTimestampReps	104
	"network.icmp.intimestampreps",
#define ICMP4_InAddrMasks	105
	"network.icmp.inaddrmasks",
#define ICMP4_InAddrMaskReps	106
	"network.icmp.inaddrmaskreps",
#define ICMP4_OutMsgs	107
	"network.icmp.outmsgs",
#define ICMP4_OutErrors	108
	"network.icmp.outerrors",
#define ICMP4_OutDestUnreachs	109
	"network.icmp.outdestunreachs",
#define ICMP4_OutTimeExcds	110
	"network.icmp.outtimeexcds",
#define ICMP4_OutParmProbs	111
	"network.icmp.outparmprobs",
#define ICMP4_OutSrcQuenchs	112
	"network.icmp.outsrcquenchs",
#define ICMP4_OutRedirects	113
	"network.icmp.outredirects",
#define ICMP4_OutEchos	114
	"network.icmp.outechos",
#define ICMP4_OutEchoReps	115
	"network.icmp.outechoreps",
#define ICMP4_OutTimestamps	116
	"network.icmp.outtimestamps",
#define ICMP4_OutTimestampReps	117
	"network.icmp.outtimestampreps",
#define ICMP4_OutAddrMasks	118
	"network.icmp.outaddrmasks",
#define ICMP4_OutAddrMaskReps	119
	"network.icmp.outaddrmaskreps",
#define TCP_RtoAlgorithm	120
	"network.tcp.rtoalgorithm",
#define TCP_RtoMin	121
	"network.tcp.rtomin",
#define TCP_RtoMax	122
	"network.tcp.rtomax",
#define TCP_MaxConn	123
	"network.tcp.maxconn",
#define TCP_ActiveOpens	124
	"network.tcp.activeopens",
#define TCP_PassiveOpens	125
	"network.tcp.passiveopens",
#define TCP_AttemptFails	126
	"network.tcp.attemptfails",
#define TCP_EstabResets	127
	"network.tcp.estabresets",
#define TCP_CurrEstab	128
	"network.tcp.currestab",
#define TCP_InSegs	129
	"network.tcp.insegs",
#define TCP_OutSegs	130
	"network.tcp.outsegs",
#define TCP_RetransSegs	131
	"network.tcp.retranssegs",
#define TCP_InErrs	132
	"network.tcp.inerrs",
#define TCP_OutRsts	133
	"network.tcp.outrsts",
#define UDPV4_InDatagrams	134
	"network.udp.indatagrams",
#define UDPV4_NoPorts	135
	"network.udp.noports",
#define UDPV4_InErrors	136
	"network.udp.inerrors",
#define UDPV4_OutDatagrams	137
	"network.udp.outdatagrams",

/* /proc/net/snmp6 */
#define IPV6_InReceives	138
	"network.ip6.inreceives",
#define IPV6_InHdrErrors	139
	"network.ip6.inhdrerrors",
#define IPV6_InTooBigErrors	140
	"network.ip6.intoobigerrors",
#define IPV6_InNoRoutes	141
	"network.ip6.innoroutes",
#define IPV6_InAddrErrors	142
	"network.ip6.inaddrerrors",
#define IPV6_InUnknownProtos	143
	"network.ip6.inunknownprotos",
#define IPV6_InTruncatedPkts	144
	"network.ip6.intruncatedpkts",
#define IPV6_InDiscards	145
	"network.ip6.indiscards",
#define IPV6_InDelivers	146
	"network.ip6.indelivers",
#define IPV6_OutForwDatagrams	147
	"network.ip6.outforwdatagrams",
#define IPV6_OutRequests	148
	"network.ip6.outrequests",
#define IPV6_OutDiscards	149
	"network.ip6.outdiscards",
#define IPV6_OutNoRoutes	150
	"network.ip6.outnoroutes",
#define IPV6_ReasmTimeout	151
	"network.ip6.reasmtimeout",
#define IPV6_ReasmReqds	152
	"network.ip6.reasmreqds",
#define IPV6_ReasmOKs	153
	"network.ip6.reasmoks",
#define IPV6_ReasmFails	154
	"network.ip6.reasmfails",
#define IPV6_FragOKs	155
	"network.ip6.fragoks",
#define IPV6_FragFails	156
	"network.ip6.fragfails",
#define IPV6_FragCreates	157
	"network.ip6.fragcreates",
#define IPV6_InMcastPkts	158
	"network.ip6.inmcastpkts",
#define IPV6_OutMcastPkts	159
	"network.ip6.outmcastpkts",
#define ICMPV6_InMsgs	160
	"network.icmp6.inmsgs",
#define ICMPV6_InErrors	161
	"network.icmp6.inerrors",
#define ICMPV6_InDestUnreachs	162
	"network.icmp6.indestunreachs",
#define ICMPV6_InPktTooBigs	163
	"network.icmp6.inpkttoobigs",
#define ICMPV6_InTimeExcds	164
	"network.icmp6.intimeexcds",
#define ICMPV6_InParmProblems	165
	"network.icmp6.inparmproblems",
#define ICMPV6_InEchos	166
	"network.icmp6.inechos",
#define ICMPV6_InEchoReplies	167
	"network.icmp6.inechoreplies",
#define ICMPV6_InGroupMembQueries	168
	"network.icmp6.ingroupmembqueries",
#define ICMPV6_InGroupMembResponses	169
	"network.icmp6.ingroupmembresponses",
#define ICMPV6_InGroupMembReductions	170
	"network.icmp6.ingroupmembreductions",
#define ICMPV6_InRouterSolicits	171
	"network.icmp6.inroutersolicits",
#define ICMPV6_InRouterAdvertisements	172
	"network.icmp6.inrouteradvertisements",
#define ICMPV6_InNeighborSolicits	173
	"network.icmp6.inneighborsolicits",
#define ICMPV6_InNeighborAdvertisements	174
	"network.icmp6.inneighboradvertisements",
#define ICMPV6_InRedirects	175
	"network.icmp6.inredirects",
#define ICMPV6_OutMsgs	176
	"network.icmp6.outmsgs",
#define ICMPV6_OutDestUnreachs	177
	"network.icmp6.outdestunreachs",
#define ICMPV6_OutPktTooBigs	178
	"network.icmp6.outpkttoobigs",
#define ICMPV6_OutTimeExcds	179
	"network.icmp6.outtimeexcds",
#define ICMPV6_OutParmProblems	180
	"network.icmp6.outparmproblems",
#define ICMPV6_OutEchoReplies	181
	"network.icmp6.outechoreplies",
#define ICMPV6_OutRouterSolicits	182
	"network.icmp6.outroutersolicits",
#define ICMPV6_OutNeighborSolicits	183
	"network.icmp6.outneighborsolicits",
#define ICMPV6_OutNeighborAdvertisements	184
	"network.icmp6.outneighboradvertisements",
#define ICMPV6_OutRedirects	185
	"network.icmp6.outredirects",
#define ICMPV6_OutGroupMembResponses	186
	"network.icmp6.outgroupmembresponses",
#define ICMPV6_OutGroupMembReductions	187
	"network.icmp6.outgroupmembreductions",
#define UDPV6_InDatagrams	188
	"network.udp6.indatagrams",
#define UDPV6_NoPorts	189
	"network.udp6.noports",
#define UDPV6_InErrors	190
	"network.udp6.inerrors",
#define UDPV6_OutDatagrams	191
	"network.udp6.outdatagrams",

/* /proc/diskstats or /proc/partitions */
#define PERDISK_NREAD	192
	"disk.dev.read",
#define PERDISK_NRSECT	193
	"disk.dev.blkread",
#define PERDISK_NWRITE	194
	"disk.dev.write",
#define PERDISK_NWSECT	195
	"disk.dev.blkwrite",
#define PERDISK_IO_MS	196
	"disk.dev.avactive",
#define PERDISK_AVEQ	197
	"disk.dev.aveq",
#define PERDM_NREAD	198
	"disk.dm.read",
#define PERDM_NRSECT	199
	"disk.dm.blkread",
#define PERDM_NWRITE	200
	"disk.dm.write",
#define PERDM_NWSECT	201
	"disk.dm.blkwrite",
#define PERMD_NREAD	202
	"disk.md.read",
#define PERMD_NRSECT	203
	"disk.md.blkread",
#define PERMD_NWRITE	204
	"disk.md.write",
#define PERMD_NWSECT	205
	"disk.md.blkwrite",

/* /proc/net/rpc/nfsd */
#define NFS_RCHITS	206
	"rpc.server.rchits",
#define NFS_RCMISS	207
	"rpc.server.rcmisses",
#define NFS_RCNOCACHE	208
	"rpc.server.rcnocache",
#define NFS_IORD	209
	"rpc.server.io_read",
#define NFS_IOWR	210
	"rpc.server.io_write",
#define NFS_NETCNT	211
	"rpc.server.netcnt",
#define NFS_UDP	212
	"rpc.server.netudpcnt",
#define NFS_TCP	213
	"rpc.server.nettcpcnt",
#define NFS_TCPCONN	214
	"rpc.server.nettcpconn",
#define NFS_RPCCNT	215
	"rpc.server.rpccnt",
#define NFS_RPCBADFMT	216
	"rpc.server.rpcbadfmt",
#define NFS_RPCBADAUTH	217
	"rpc.server.rpcbadauth",
#define NFS_RPCBADCLNT	218
	"rpc.server.rpcbadclnt",
#define NFS_REQS	219
	"nfs.server.reqs",
#define NFS3_REQS	220
	"nfs3.server.reqs",
#define NFS4_REQS	221
	"nfs4.server.reqs",

/* /proc/net/rpc/nfs */
#define NFC_RPCCNT	222
	"rpc.client.rpccnt",
#define NFC_RETRANS	223
	"rpc.client.rpcretrans",
#define NFC_AUTHREFRESH	224
	"rpc.client.rpcauthrefresh",
#define NFC_REQS	225
	"nfs.client.reqs",
#define NFC3_REQS	226
	"nfs3.client.reqs",
#define NFC4_REQS	227
	"nfs4.client.reqs",

/* /proc/self/mountstats */
#define PERNFS_EXPORT	228
	"nfsclient.export",
#define PERNFS_AGE	229
	"nfsclient.age",
#define PERNFS_RDBYTES	230
	"nfsclient.bytes.read.normal",
#define PERNFS_WRBYTES	231
	"nfsclient.bytes.write.normal",
#define PERNFS_DRDBYTES	232
	"nfsclient.bytes.read.direct",
#define PERNFS_DWRBYTES	233
	"nfsclient.bytes.write.direct",
#define PERNFS_TOTRDBYTES	234
	"nfsclient.bytes.read.server",
#define PERNFS_TOTWRBYTES	235
	"nfsclient.bytes.write.server",
#define PERNFS_RDPAGES	236
	"nfsclient.pages.read",
#define PERNFS_WRPAGES	237
	"nfsclient.pages.write",

/* /proc/pressure/{cpu,memory,io} */
#define PSI_CPUSOME_AVG	238
	"kernel.all.pressure.cpu.some.avg",
#define PSI_CPUSOME_TOTAL	239
	"kernel.all.pressure.cpu.some.total",
#define PSI_MEMSOME_AVG	240
	"kernel.all.pressure.memory.some.avg",
#define PSI_MEMSOME_TOTAL	241
	"kernel.all.pressure.memory.some.total",
#define PSI_MEMFULL_AVG	242
	"kernel.all.pressure.memory.full.avg",
#define PSI_MEMFULL_TOTAL	243
	"kernel.all.pressure.memory.full.total",
#define PSI_IOSOME_AVG	244
	"kernel.all.pressure.io.some.avg",
#define PSI_IOSOME_TOTAL	245
	"kernel.all.pressure.io.some.total",
#define PSI_IOFULL_AVG	246
	"kernel.all.pressure.io.full.avg",
#define PSI_IOFULL_TOTAL	247
	"kernel.all.pressure.io.full.total",

/* hardware events */
#define PERCPU_PERF_INSTR	248
	"perfevent.hwcounters.INSTRUCTIONS_RETIRED.value",
#define PERCPU_PERF_CYCLE	249
	"perfevent.hwcounters.UNHALTED_REFERENCE_CYCLES.value",

/* Infiniband */
#define PERIFB_PORT_LID	250
	"infiniband.port.lid",
#define PERIFB_PORT_RATE	251
	"infiniband.port.rate",
#define PERIFB_PORT_WIDTH	252
	"infiniband.port.linkwidth",
#define PERIFB_PORT_INB	253
	"infiniband.port.in.bytes",
#define PERIFB_PORT_OUTB	254
	"infiniband.port.out.bytes",
#define PERIFB_PORT_INPKT	255
	"infiniband.port.in.packets",
#define PERIFB_PORT_OUTPKT	256
	"infiniband.port.out.packets",

/* http status */
#define WWW_ACCESSES	257
	"apache.total_accesses",
#define WWW_TOTKBYTES	258
	"apache.total_kbytes",
#define WWW_UPTIME	259
	"apache.uptime",
#define WWW_BWORKERS	260
	"apache.busy_servers",
#define WWW_IWORKERS	261
	"apache.idle_servers",

/* end marker - provides count */
#define SYST_NMETRICS	262
	".",

};

